"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _selectors = require("./selectors");
/*
 * Copyright 2022 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

class Markdown {
  constructor() {
    this.tip = '.kui--markdown-tip';
    this.tabs = '.kui--markdown-tabs';
    this.tab = `${this.tabs} .kui--markdown-tab button`;
    this.icon = `${_selectors.PROMPT_BLOCK} .kui--markdown-icon`;
    this._codeBlock = '.kui--code-block-in-markdown';
    this.runButton = '.kui--block-action-run';
    this.cleanupButton = '.kui--block-action-cleanup';
  }
  getText(ctx) {
    return ctx.app.client.$(_selectors.OUTPUT_LAST).then(_ => _.getText());
  }
  tipWithTitle(title) {
    return `${this.tip}[data-title="${title}"]`;
  }
  tipContent(baseSelector = this.tip) {
    return `${baseSelector} > div`;
  }
  tabWithTitle(title) {
    return `${this.tab}[data-title="${title}"]`;
  }
  codeBlock(index) {
    return `${this._codeBlock}[data-code-index="${index}"]`;
  }
}
exports.default = Markdown;