"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  Sidebar: true,
  Markdown: true,
  Wizard: true
};
exports.Wizard = exports.Sidebar = exports.Markdown = void 0;
var _Sidebar = _interopRequireDefault(require("./Sidebar"));
var _Markdown = _interopRequireDefault(require("./Markdown"));
var _Wizard = _interopRequireDefault(require("./Wizard"));
var _selectors = require("./selectors");
Object.keys(_selectors).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _selectors[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _selectors[key];
    }
  });
});
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/*
 * Copyright 2021 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

const Sidebar = new _Sidebar.default();
exports.Sidebar = Sidebar;
const Markdown = new _Markdown.default();
exports.Markdown = Markdown;
const Wizard = new _Wizard.default();
exports.Wizard = Wizard;