"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
 * Copyright 2022 The Kubernetes Authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class Wizard {
  constructor() {
    this.wizard = '.kui--wizard';
    this.title = '.pf-c-wizard__title';
    this._description = '.pf-c-wizard__description';
    this._navItem = '.pf-c-wizard__nav-item';
    this._navItemTitle = '.pf-c-wizard__nav-link';
    this.isCurrentStep = 'pf-m-current';
    this._navItemDescription = '.kui--wizard-nav-item-description';
    this._navItemProgressStepper = '.kui--progress-stepper';
    this._navItemProgressStep = '.kui--progress-step';
    this._body = '.pf-c-wizard__main-body';
    this._wizardProgressMeasure = '.pf-c-progress__measure';
  }
  withTitle(title) {
    return `${this.wizard} ${this.title}[aria-label="${title}"]`;
  }
  get description() {
    return `${this.wizard} ${this._description}`;
  }
  get body() {
    return `${this.wizard} ${this._body}`;
  }
  navItem(idx) {
    return `${this.wizard} ${this._navItem}:nth-child(${idx + 1})`;
  }
  navItemSwitchToButton(idx) {
    return `${this.navItem(idx)} > button`;
  }
  navItemTitle(idx) {
    return `${this.navItem(idx)} ${this._navItemTitle}`;
  }
  navItemDescription(idx) {
    return `${this.navItem(idx)} ${this._navItemDescription}`;
  }
  navItemProgressStepper(idx) {
    return `${this.navItem(idx)} ${this._navItemProgressStepper}`;
  }
  navItemProgressSteps(idx) {
    return `${this.navItemProgressStepper(idx)} ${this._navItemProgressStep}`;
  }
  navItemProgressStep(navIdx, stepIdx) {
    return `${this.navItemProgressSteps(navIdx)}:nth-child(${stepIdx + 1})`;
  }
  get progressMeasure() {
    return `${this.wizard} ${this._wizardProgressMeasure}`;
  }
}
exports.default = Wizard;