import { Application } from 'spectron';
import * as Common from './common';
import { AppAndCount } from './repl-expect';
export declare const timeout: number;
export declare const waitTimeout: number;
export declare const waitTimeoutOption: {
    timeout: number;
};
/** grab focus for the repl */
export declare const grabFocus: (app: Application, currentPromptBlock?: string, currentPrompt?: string) => Promise<any>;
/**
 * Execute a CLI command, and return the data-input-count of that command
 *
 */
export declare const command: (cmd: string, app: Application, noNewline?: boolean, noCopyPaste?: boolean, noFocus?: boolean, block?: string, currentPrompt?: string) => Promise<{
    app: Application;
    count: number;
}>;
/** Execute the given command in the given split */
export declare const commandInSplit: (cmd: string, app: Application, splitIndex: number) => Promise<{
    app: Application;
    count: number;
} & {
    splitIndex: number;
}>;
export declare const paste: (cmd: string, app: Application, nLines?: number) => Promise<{
    app: Application;
    count: number;
}>;
/** wait for the repl to be active */
export declare const waitForRepl: (app: Application) => Promise<Application>;
/**
 * Wait, if needed, for a proxy session
 *
 */
export declare const waitForSession: (ctx: Common.ISuite, noProxySessionWait?: boolean) => Promise<void>;
export declare const getTextContent: (app: Application, selector: string) => Promise<string>;
/** wait for the result of a cli.command */
export declare const makeCustom: (selector: string, expect: string, exact?: boolean) => {
    selector: string;
    expect: string;
    exact: boolean;
};
/**
 * Exit code code for the given http status code; this is an identity function; for headless mode, there is the -256 part.
 * See headless.js for the analogous headless implementation.
 */
export declare const exitCode: (statusCode: number | string) => string | number;
export declare const expectInput: (selector: string, expectedText: string) => (app: Application) => Promise<Application>;
/** text repl input context text */
export declare function expectInputContext(res: AppAndCount, N: number, expectedText: string, exact?: boolean): Promise<any>;
export declare const expectPriorInput: (selector: string, expectedText: string) => (app: Application) => Promise<Application>;
/** @return the "N" of the current block */
export declare function nOfCurrentBlock(app: Application, splitIndex?: number): Promise<number>;
/** Index of last executed block */
export declare function lastBlock(app: Application, splitIndex?: number, N?: number, inNotebook?: boolean): Promise<AppAndCount>;
/** Click to expand the last replayed sample output */
export declare function expandNth(app: Application, N: number, splitIndex?: number): Promise<void>;
/** Click to expand the last replayed sample output */
export declare function expandLast(app: Application, splitIndex?: number, N?: number): Promise<void>;
