import { Application } from 'spectron';
import { ISuite } from './common';
export interface AppAndCount {
    app: Application;
    count: number;
    splitIndex?: number;
}
interface CustomSpec {
    selector?: string;
    errOk?: boolean;
    expect?: string;
    exact?: boolean;
    passthrough?: boolean;
    streaming?: boolean;
}
export declare const ok: (res: AppAndCount) => Promise<AppAndCount>;
export declare const error: (statusCode: number | string, expect?: string) => (res: AppAndCount) => Promise<Application>;
export declare const blankWithOpts: (opts?: {}) => (res: AppAndCount) => Promise<boolean>;
export declare const blank: (res: AppAndCount) => Promise<boolean>;
/** The return type `any` comes from webdriverio waitUntil */
export declare const consoleToBeClear: (app: Application, residualBlockCount?: number, splitIndex?: number) => Promise<true | void>;
/** as long as its ok, accept anything */
export declare const okWithCustom: <T extends string | boolean>(custom: CustomSpec) => (res: AppAndCount) => Promise<T>;
export declare const okWithTextContent: (expect: string, exact?: boolean, failFast?: boolean, sel?: string) => (res: AppAndCount) => Promise<boolean>;
export declare const okWithString: (expect: string, exact?: boolean, streaming?: boolean) => (res: AppAndCount) => Promise<boolean>;
export declare const okWithStreamingOutput: (expect: string, exact?: boolean) => (res: AppAndCount) => Promise<boolean>;
export declare const okWithPtyOutput: (expect: string, exact?: boolean) => (res: AppAndCount) => Promise<boolean>;
export declare const okWithStringEventually: (expect: string, exact?: boolean) => (res: AppAndCount) => Promise<true | void>;
export declare const okWithPtyOutputEventually: (expect: string, exact?: boolean) => (res: AppAndCount) => Promise<true | void>;
export declare const okWithDropDownList: (openAndExpectLabel: string, click?: boolean, closeAfterOpen?: boolean) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const okWithEvents: (ctx: ISuite, res: AppAndCount) => Promise<AppAndCount>;
/** as long as its ok, accept anything */
export declare const okWithAny: (res: AppAndCount) => Promise<boolean>;
/** expect ok and *only* the given result value */
export declare const okWithOnly: (entityName: string) => (res: AppAndCount) => Promise<boolean>;
/** expect ok and at least the given result value */
export declare const okWith: (entityName: string) => (res: AppAndCount) => Promise<boolean>;
/** expect just ok, and no result value */
export declare const justOK: (res: AppAndCount) => Promise<AppAndCount>;
/** Expect the given number of terminal splits in the current tab, and check whether the last split has inverse colors */
export declare function splitCount(expectedSplitCount: number, inverseColors?: boolean, expectedSplitIndex?: number): (app: Application) => Promise<void>;
/** Expect table with N rows */
export declare function tableWithNRows(N: number): (res: AppAndCount) => Promise<true | void>;
/** Expect an ElsewhereCommentaryResponse */
export declare function elsewhere(expectedBody: string, N?: number): (res: AppAndCount) => Promise<Application>;
/** Expect a CommentaryResponse */
export declare function comment(expectedBody: string, expectedTitle?: string): (res: AppAndCount) => Promise<AppAndCount>;
/** Verify that the number of blocks equals the expected count */
export declare function blockCount(this: ISuite): {
    inSplit: (splitIndex: number) => {
        is: (expected: number | (() => number)) => void;
    };
};
/** Transform the given block finder to one that can find the next block */
export declare function blockAfter(res: AppAndCount, delta?: number): AppAndCount;
export {};
