import { AppAndCount } from './repl-expect';
export declare const open: (res: AppAndCount) => Promise<AppAndCount>;
/** Same as open(), but in the block proceding the given block */
export declare function openInBlockAfter(res: AppAndCount, delta?: number): Promise<AppAndCount>;
export declare const notOpen: (res: AppAndCount) => Promise<AppAndCount>;
export declare const openWithFailure: (res: AppAndCount) => Promise<AppAndCount>;
/** fully closed, not just minimized */
export declare const fullyClosed: (res: AppAndCount) => Promise<AppAndCount>;
/** either minimized or fully closed */
export declare const closed: (res: AppAndCount) => Promise<AppAndCount>;
/** close the sidecar by ESCAPE key */
export declare const keyToClose: (res: AppAndCount) => Promise<AppAndCount>;
/** Expect the given badge to exist in the sidecar header */
export declare const badge: (title: string, css?: string, absent?: boolean) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const button: (button: {
    mode: string;
    label?: string;
}) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const mode: (expectedMode: string) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const toolbarText: (expect: {
    type: string;
    text: string;
    exact?: boolean;
    timeout?: number;
}) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const toolbarAlert: (expect: {
    type: string;
    text: string;
    exact?: boolean;
}) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const name: (count: number, expectedName: string) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const namehash: (count: number, expectedNameHash: string) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const namespace: (expectedNamespace: string) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const kind: (expectedKind: string) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const modes: (expected: {
    mode: string;
    label?: string;
    dafaultMode?: boolean;
}[]) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const defaultMode: (expected: {
    mode: string;
    label?: string;
}) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const textPlainContent: (content: string) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const textPlainContentFromMonaco: (expectedText: string, exact?: boolean) => (res: AppAndCount) => Promise<AppAndCount>;
export declare function tableContent(res: AppAndCount, nRows: number, nCells: number): Promise<void>;
export declare const yaml: (content: object) => (res: AppAndCount) => Promise<AppAndCount>;
export declare function popupTitle(res: AppAndCount, expectedTitle: string): Promise<true | void>;
/** expect a form in the sidecar content */
export declare function form(form: Record<string, string>, idPrefix?: string): (res: AppAndCount) => Promise<AppAndCount>;
export declare const showing: (expectedName: string, expectedActivationId?: string, expectSubstringMatchOnName?: boolean, expectedPackageName?: string, expectType?: string, waitThisLong?: number, which?: 'leftnav' | 'topnav', clickable?: boolean) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const showingNotClickable: (expectedName: string, expectedPackageName?: string) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const showingTopNav: (expectedName: string) => (res: AppAndCount) => Promise<AppAndCount>;
export declare const showingLeftNav: (expectedName: string) => (res: AppAndCount) => Promise<AppAndCount>;
export declare function breadcrumbs(breadcrumbs: string[]): (res: AppAndCount) => Promise<AppAndCount>;
/** Expect DescriptionList content in the current tab */
export declare const descriptionList: (content: Record<string, number | boolean | string>) => (res: AppAndCount) => Promise<AppAndCount>;
