import { Table } from '@kui-shell/core';
import * as Common from './common';
interface RowWithBadgeAndMessage {
    name: string;
    badgeCss: string;
    badgeText: string;
    message: string;
}
interface TableValidation {
    hasGridButton?: boolean;
    hasSequenceButton?: boolean;
    cells?: ((value: string, rowIdx: number) => void)[];
    asGrid?: boolean;
    switchToSequence?: boolean;
    bars?: string[];
    switchToList?: boolean;
}
interface Tests {
    exec?: {
        command: string;
        expectTable: Table;
        validation?: TableValidation;
    };
    drilldown?: {
        expectTable: Table;
    };
    status?: {
        expectRow: RowWithBadgeAndMessage[];
        command: string;
        statusDescription?: string;
    };
}
export declare class TestTable {
    private testName;
    private outputCount;
    private ctx;
    private tests;
    private cmdIdx;
    constructor(testName?: string, tests?: Tests);
    /** new TestTable().run() will start a mocha test suite */
    run(): void;
    evalStatus(_: {
        expectRow: RowWithBadgeAndMessage[];
        command: string;
        statusDescription?: string;
        ctx?: Common.ISuite;
    }): void;
    /**
     * Execute the table-generating command, and validate the content.
     *
     */
    private executeAndValidate;
    /**
     * drilldownFromTable() drilldowns from the table
     *
     * @param { Table } expectTable is the expected table shown in the REPL
     *
     */
    drilldownFromTable(expectTable: Table, _ctx?: Common.ISuite): void;
}
export {};
