import { Application } from 'spectron';
import * as Common from './common';
import * as ReplExpect from './repl-expect';
export interface AppAndCount {
    app: Application;
    count: number;
    splitIndex?: number;
}
export declare const expectSubset: (struct1: object, failFast?: boolean) => (str: string) => boolean;
/** is the given struct2 the same as the given struct2 (given as a string) */
export declare const expectStruct: (struct1: object, noParse?: boolean, failFast?: boolean) => (str: string) => boolean;
export declare const expectYAML: (struct1: object, subset?: boolean, failFast?: boolean) => (str: string) => boolean;
export declare const expectYAMLSubset: (struct1: object, failFast?: boolean) => (str: string) => boolean;
/** is the given actual array the same as the given expected array? */
export declare const expectArray: (expected: Array<string>, failFast?: boolean, subset?: boolean) => (actual: string | Array<string>) => boolean;
/** Expand the fold on the given line of a monaco editor */
export declare function clickToExpandMonacoFold(res: AppAndCount, lineIdx: number): Promise<void>;
/** get the monaco editor text */
export declare const getValueFromMonaco: (res: AppAndCount, container?: string) => Promise<string>;
export declare const waitForXtermInput: (app: Application, N: number) => Promise<any>;
export declare const expectText: (app: Application, expectedText: string, exact?: boolean, timeout?: number) => (selector: string) => Promise<Application>;
/** @return the current number of tabs */
export declare function tabCount(app: Application): Promise<number>;
/** Close all except the first tab */
export declare function closeAllExceptFirstTab(this: Common.ISuite, expectedInitialNTabs?: number): void;
export declare function uniqueFileForSnapshot(): string;
/** Click the specified button action button */
export declare function clickBlockActionButton(res: AppAndCount, buttonSelector: string): Promise<void>;
/** Click the close button on a block, and expect it to be gone */
export declare function removeBlock(res: AppAndCount): Promise<void>;
/** Click the block copy button */
export declare function copyBlockLink(res: AppAndCount): Promise<void>;
/** Click the block run button */
export declare function rerunCommand(res: AppAndCount): Promise<void>;
/** Switch sidecar tab */
export declare function switchToTab(mode: string): (res: AppAndCount) => Promise<AppAndCount>;
/** Output of the given block */
export declare function outputOf(res: AppAndCount): Promise<any>;
/**
 * Execute `command` and expect a table with `name`
 *
 */
export declare function doList(ctx: Common.ISuite, command: string, name: string): Promise<string>;
export declare function openSidecarByClick(ctx: Common.ISuite, selector: string, name: string, mode?: string, activationId?: string, splitIndex?: number, // after we click, we expect two splits
inNotebook?: boolean): Promise<ReplExpect.AppAndCount>;
/**
 * Execute `command` and expect a table with `name`,
 * and then open sidecar by clicking the `name`
 *
 */
export declare function listAndOpenSidecarNoWait(ctx: Common.ISuite, command: string, name: string, mode?: string): Promise<ReplExpect.AppAndCount>;
/**
 * Click sidecar mode button by `mode`
 *
 */
export declare function clickSidecarModeButton(ctx: Common.ISuite, res: AppAndCount, mode: string): Promise<void>;
/**
 * Click a sidecar button with `selector`
 *
 */
export declare function clickSidecarButtonCustomized(ctx: Common.ISuite, res: AppAndCount, selector: string): Promise<void>;
export declare function doCancel(this: Common.ISuite, cmd?: string): Promise<unknown>;
export declare function switchToTopLevelTabViaClick(ctx: Common.ISuite, N: number): Promise<any>;
export declare function doClear(this: Common.ISuite, residualBlockCount?: number, splitIndex?: number): Promise<void>;
export declare function clickNewTabButton(ctx: Common.ISuite, expectedNewTabIndex: number): Promise<Application>;
export declare function getTabTitle(ctx: Common.ISuite, tabTitleSelector: string): Promise<any>;
export declare function expectCurrentTabTitle(ctx: Common.ISuite, expectedTabTitle: string, tabTitleSelector?: string): Promise<true | void>;
