# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.

## [13.1.4](https://github.com/kubernetes-sigs/kui/compare/v13.1.3...v13.1.4) (2023-04-20)

**Note:** Version bump only for package @kui-shell/test





## [13.1.3](https://github.com/kubernetes-sigs/kui/compare/v13.1.2...v13.1.3) (2023-03-25)

**Note:** Version bump only for package @kui-shell/test





## [13.1.2](https://github.com/kubernetes-sigs/kui/compare/v13.1.1...v13.1.2) (2023-03-25)

**Note:** Version bump only for package @kui-shell/test





## [13.1.1](https://github.com/kubernetes-sigs/kui/compare/v13.1.0...v13.1.1) (2023-02-22)

**Note:** Version bump only for package @kui-shell/test





# [13.1.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v13.1.0) (2023-02-03)


### Bug Fixes

* **packages/core:** Events api created and typedoc documentation generated ([531461d](https://github.com/kubernetes-sigs/kui/commit/531461d))
* **packages/core:** Util and Themes APIs added and updated documentation ([b175698](https://github.com/kubernetes-sigs/kui/commit/b175698))
* **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
* **packages/test:** tests may fail because active prompt is not in view ([c61f9a5](https://github.com/kubernetes-sigs/kui/commit/c61f9a5))
* **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
* **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
* **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
* **plugins/plugin-client-common:** markdown mark tags sometimes confused with tabbed ([405201c](https://github.com/kubernetes-sigs/kui/commit/405201c))
* **plugins/plugin-client-common:** markdown with non-tab/tip indentation formats poorly ([7cd9a9e](https://github.com/kubernetes-sigs/kui/commit/7cd9a9e))
* **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
* **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
* **plugins/plugin-kubectl:** use markdown kube icon, rather than hard-coded svg content ([7ae94d3](https://github.com/kubernetes-sigs/kui/commit/7ae94d3))
* "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
* Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
* don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
* improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
* improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
* multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
* notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
* restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
* sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
* Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
* tip without title parsing improvements ([d31c2f6](https://github.com/kubernetes-sigs/kui/commit/d31c2f6)), closes [#8417](https://github.com/kubernetes-sigs/kui/issues/8417)
* **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
* **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
* **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
* **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
* **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
* kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
* kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
* kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
* reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
* remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
* terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
* tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
* use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
* **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
* **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
* **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
* **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
* improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
* **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
* about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
* allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
* another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
* avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
* eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
* hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
* improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
* improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
* improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
* Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
* kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
* kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
* sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
* **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
* **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
* Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
* reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
* remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
* return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
* sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
* sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
* **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
* **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
* **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
* **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
* **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
* **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
* **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
* **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
* **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)


### chore

* load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)


### Features

* bump to electron 22 ([5a77cc5](https://github.com/kubernetes-sigs/kui/commit/5a77cc5))
* **plugins/plugin-client-common:** infer Wizard from guidebook DAG ([d16c30d](https://github.com/kubernetes-sigs/kui/commit/d16c30d))
* add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
* add guidebook code block cleanup support ([70723ed](https://github.com/kubernetes-sigs/kui/commit/70723ed))
* clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
* Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
* remove bottom strip support and replace with right strip support ([27d06a1](https://github.com/kubernetes-sigs/kui/commit/27d06a1))
* **plugins/plugin-client-common:** allow wizard header to be collapsed ([e8b9c2c](https://github.com/kubernetes-sigs/kui/commit/e8b9c2c))
* add support for left strip positioning of terminal splits ([a8dc71f](https://github.com/kubernetes-sigs/kui/commit/a8dc71f)), closes [#8202](https://github.com/kubernetes-sigs/kui/issues/8202)
* execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
* improve consistency of input element coloring between guidebooks and plain terminals ([d5bac1d](https://github.com/kubernetes-sigs/kui/commit/d5bac1d))
* **plugins/plugin-client-common:** assign code blocks an ordinal execution order ([c685b94](https://github.com/kubernetes-sigs/kui/commit/c685b94))
* **plugins/plugin-client-common:** initial support for code block ordering ([adc8beb](https://github.com/kubernetes-sigs/kui/commit/adc8beb))
* add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
* background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
* bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
* extend markdown tab syntax to be presented as a Wizard UI ([173e436](https://github.com/kubernetes-sigs/kui/commit/173e436))
* head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
* improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
* initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
* inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
* introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
* inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
* link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
* Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
* Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
* save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
* section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
* SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
* support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
* Use patternfly Sidebar to display guidebooks ([d2333e4](https://github.com/kubernetes-sigs/kui/commit/d2333e4))
* **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
* custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
* initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
* pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
* preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
* show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
* support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
* use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
* use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
* use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
* use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
* view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
* When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
* **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
* **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
* **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
* **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
* **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
* **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
* **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
* **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
* **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
* add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
* add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
* add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
* add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
* add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
* add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
* add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
* add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
* add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
* allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
* allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
* carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
* generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
* improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
* kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
* kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
* left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
* pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
* **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
* **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
* **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
* **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
* **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
* clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
* client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
* command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
* enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
* MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
* new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
* pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
* port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
* pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
* refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
* render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
* resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
* split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
* support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
* support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
* support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
* target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
* top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
* use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
* watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
* **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
* **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)


### Tests

* get rid of test/testv2 distinction (use testv2 impls) ([3f34fee](https://github.com/kubernetes-sigs/kui/commit/3f34fee))


### BREAKING CHANGES

* any clients that relied on old test impls
* this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous





# [13.0.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v13.0.0) (2023-01-13)


### Bug Fixes

* **packages/core:** Events api created and typedoc documentation generated ([531461d](https://github.com/kubernetes-sigs/kui/commit/531461d))
* **packages/core:** Util and Themes APIs added and updated documentation ([b175698](https://github.com/kubernetes-sigs/kui/commit/b175698))
* **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
* **packages/test:** tests may fail because active prompt is not in view ([c61f9a5](https://github.com/kubernetes-sigs/kui/commit/c61f9a5))
* **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
* **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
* **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
* **plugins/plugin-client-common:** markdown mark tags sometimes confused with tabbed ([405201c](https://github.com/kubernetes-sigs/kui/commit/405201c))
* **plugins/plugin-client-common:** markdown with non-tab/tip indentation formats poorly ([7cd9a9e](https://github.com/kubernetes-sigs/kui/commit/7cd9a9e))
* **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
* **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
* **plugins/plugin-kubectl:** use markdown kube icon, rather than hard-coded svg content ([7ae94d3](https://github.com/kubernetes-sigs/kui/commit/7ae94d3))
* "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
* Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
* don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
* improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
* improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
* multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
* notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
* restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
* sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
* Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
* tip without title parsing improvements ([d31c2f6](https://github.com/kubernetes-sigs/kui/commit/d31c2f6)), closes [#8417](https://github.com/kubernetes-sigs/kui/issues/8417)
* **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
* **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
* **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
* **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
* **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
* kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
* kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
* kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
* reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
* remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
* terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
* tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
* use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
* **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
* **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
* **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
* **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
* improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
* **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
* about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
* allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
* another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
* avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
* eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
* hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
* improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
* improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
* improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
* Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
* kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
* kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
* sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
* **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
* **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
* Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
* reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
* remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
* return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
* sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
* sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
* **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
* **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
* **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
* **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
* **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
* **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
* **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
* **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
* **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)


### chore

* load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)


### Features

* bump to electron 22 ([5a77cc5](https://github.com/kubernetes-sigs/kui/commit/5a77cc5))
* **plugins/plugin-client-common:** infer Wizard from guidebook DAG ([d16c30d](https://github.com/kubernetes-sigs/kui/commit/d16c30d))
* add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
* add guidebook code block cleanup support ([70723ed](https://github.com/kubernetes-sigs/kui/commit/70723ed))
* clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
* Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
* remove bottom strip support and replace with right strip support ([27d06a1](https://github.com/kubernetes-sigs/kui/commit/27d06a1))
* **plugins/plugin-client-common:** allow wizard header to be collapsed ([e8b9c2c](https://github.com/kubernetes-sigs/kui/commit/e8b9c2c))
* add support for left strip positioning of terminal splits ([a8dc71f](https://github.com/kubernetes-sigs/kui/commit/a8dc71f)), closes [#8202](https://github.com/kubernetes-sigs/kui/issues/8202)
* execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
* improve consistency of input element coloring between guidebooks and plain terminals ([d5bac1d](https://github.com/kubernetes-sigs/kui/commit/d5bac1d))
* **plugins/plugin-client-common:** assign code blocks an ordinal execution order ([c685b94](https://github.com/kubernetes-sigs/kui/commit/c685b94))
* **plugins/plugin-client-common:** initial support for code block ordering ([adc8beb](https://github.com/kubernetes-sigs/kui/commit/adc8beb))
* add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
* background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
* bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
* extend markdown tab syntax to be presented as a Wizard UI ([173e436](https://github.com/kubernetes-sigs/kui/commit/173e436))
* head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
* improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
* initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
* inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
* introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
* inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
* link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
* Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
* Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
* save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
* section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
* SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
* support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
* Use patternfly Sidebar to display guidebooks ([d2333e4](https://github.com/kubernetes-sigs/kui/commit/d2333e4))
* **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
* custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
* initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
* pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
* preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
* show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
* support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
* use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
* use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
* use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
* use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
* view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
* When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
* **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
* **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
* **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
* **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
* **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
* **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
* **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
* **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
* **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
* add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
* add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
* add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
* add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
* add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
* add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
* add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
* add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
* add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
* allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
* allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
* carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
* generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
* improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
* kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
* kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
* left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
* pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
* **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
* **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
* **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
* **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
* **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
* clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
* client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
* command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
* enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
* MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
* new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
* pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
* port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
* pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
* refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
* render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
* resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
* split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
* support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
* support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
* support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
* target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
* top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
* use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
* watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
* **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
* **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)


### Tests

* get rid of test/testv2 distinction (use testv2 impls) ([3f34fee](https://github.com/kubernetes-sigs/kui/commit/3f34fee))


### BREAKING CHANGES

* any clients that relied on old test impls
* this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous





# [12.2.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v12.2.0) (2022-10-10)


### Bug Fixes

* **packages/core:** Events api created and typedoc documentation generated ([531461d](https://github.com/kubernetes-sigs/kui/commit/531461d))
* **packages/core:** Util and Themes APIs added and updated documentation ([b175698](https://github.com/kubernetes-sigs/kui/commit/b175698))
* **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
* **packages/test:** tests may fail because active prompt is not in view ([c61f9a5](https://github.com/kubernetes-sigs/kui/commit/c61f9a5))
* **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
* **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
* **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
* **plugins/plugin-client-common:** markdown mark tags sometimes confused with tabbed ([405201c](https://github.com/kubernetes-sigs/kui/commit/405201c))
* **plugins/plugin-client-common:** markdown with non-tab/tip indentation formats poorly ([7cd9a9e](https://github.com/kubernetes-sigs/kui/commit/7cd9a9e))
* **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
* **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
* **plugins/plugin-kubectl:** use markdown kube icon, rather than hard-coded svg content ([7ae94d3](https://github.com/kubernetes-sigs/kui/commit/7ae94d3))
* "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
* Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
* don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
* improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
* improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
* multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
* notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
* restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
* sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
* Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
* tip without title parsing improvements ([d31c2f6](https://github.com/kubernetes-sigs/kui/commit/d31c2f6)), closes [#8417](https://github.com/kubernetes-sigs/kui/issues/8417)
* **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
* **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
* **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
* **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
* **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
* kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
* kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
* kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
* reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
* remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
* terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
* tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
* use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
* **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
* **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
* **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
* **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
* improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
* **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
* about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
* allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
* another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
* avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
* eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
* hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
* improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
* improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
* improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
* Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
* kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
* kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
* sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
* **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
* **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
* Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
* reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
* remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
* return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
* sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
* sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
* **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
* **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
* **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
* **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
* **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
* **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
* **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
* **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
* **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)


### chore

* load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)


### Features

* **plugins/plugin-client-common:** infer Wizard from guidebook DAG ([d16c30d](https://github.com/kubernetes-sigs/kui/commit/d16c30d))
* add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
* add guidebook code block cleanup support ([70723ed](https://github.com/kubernetes-sigs/kui/commit/70723ed))
* add support for left strip positioning of terminal splits ([a8dc71f](https://github.com/kubernetes-sigs/kui/commit/a8dc71f)), closes [#8202](https://github.com/kubernetes-sigs/kui/issues/8202)
* add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
* background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
* bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
* clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
* custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
* execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
* Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
* extend markdown tab syntax to be presented as a Wizard UI ([173e436](https://github.com/kubernetes-sigs/kui/commit/173e436))
* improve consistency of input element coloring between guidebooks and plain terminals ([d5bac1d](https://github.com/kubernetes-sigs/kui/commit/d5bac1d))
* improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
* remove bottom strip support and replace with right strip support ([27d06a1](https://github.com/kubernetes-sigs/kui/commit/27d06a1))
* **plugins/plugin-client-common:** allow wizard header to be collapsed ([e8b9c2c](https://github.com/kubernetes-sigs/kui/commit/e8b9c2c))
* **plugins/plugin-client-common:** assign code blocks an ordinal execution order ([c685b94](https://github.com/kubernetes-sigs/kui/commit/c685b94))
* **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
* **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
* **plugins/plugin-client-common:** initial support for code block ordering ([adc8beb](https://github.com/kubernetes-sigs/kui/commit/adc8beb))
* head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
* initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
* initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
* inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
* introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
* inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
* link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
* Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
* Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
* pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
* preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
* save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
* section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
* show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
* SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
* support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
* support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
* use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
* use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
* use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
* Use patternfly Sidebar to display guidebooks ([d2333e4](https://github.com/kubernetes-sigs/kui/commit/d2333e4))
* use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
* view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
* When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
* **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
* **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
* **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
* **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
* **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
* **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
* **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
* **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
* **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)
* add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
* add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
* add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
* add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
* add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
* add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
* add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
* add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
* add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
* allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
* carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
* clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
* command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
* generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
* improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
* kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
* kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
* pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
* **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
* **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
* **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
* **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
* **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
* allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
* **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
* client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
* enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
* left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
* MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
* new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
* pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
* port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
* pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
* refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
* render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
* resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
* split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
* support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
* support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
* support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
* target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
* top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
* use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
* watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)


### Tests

* get rid of test/testv2 distinction (use testv2 impls) ([3f34fee](https://github.com/kubernetes-sigs/kui/commit/3f34fee))


### BREAKING CHANGES

* any clients that relied on old test impls
* this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous





# [12.0.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v12.0.0) (2022-09-06)

### Bug Fixes

- **packages/core:** Events api created and typedoc documentation generated ([531461d](https://github.com/kubernetes-sigs/kui/commit/531461d))
- **packages/core:** Util and Themes APIs added and updated documentation ([b175698](https://github.com/kubernetes-sigs/kui/commit/b175698))
- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **packages/test:** tests may fail because active prompt is not in view ([c61f9a5](https://github.com/kubernetes-sigs/kui/commit/c61f9a5))
- **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** markdown mark tags sometimes confused with tabbed ([405201c](https://github.com/kubernetes-sigs/kui/commit/405201c))
- **plugins/plugin-client-common:** markdown with non-tab/tip indentation formats poorly ([7cd9a9e](https://github.com/kubernetes-sigs/kui/commit/7cd9a9e))
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- **plugins/plugin-kubectl:** use markdown kube icon, rather than hard-coded svg content ([7ae94d3](https://github.com/kubernetes-sigs/kui/commit/7ae94d3))
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- tip without title parsing improvements ([d31c2f6](https://github.com/kubernetes-sigs/kui/commit/d31c2f6)), closes [#8417](https://github.com/kubernetes-sigs/kui/issues/8417)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)

### chore

- load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)

### Features

- **plugins/plugin-client-common:** infer Wizard from guidebook DAG ([d16c30d](https://github.com/kubernetes-sigs/kui/commit/d16c30d))
- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- add guidebook code block cleanup support ([70723ed](https://github.com/kubernetes-sigs/kui/commit/70723ed))
- add support for left strip positioning of terminal splits ([a8dc71f](https://github.com/kubernetes-sigs/kui/commit/a8dc71f)), closes [#8202](https://github.com/kubernetes-sigs/kui/issues/8202)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- extend markdown tab syntax to be presented as a Wizard UI ([173e436](https://github.com/kubernetes-sigs/kui/commit/173e436))
- improve consistency of input element coloring between guidebooks and plain terminals ([d5bac1d](https://github.com/kubernetes-sigs/kui/commit/d5bac1d))
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- remove bottom strip support and replace with right strip support ([27d06a1](https://github.com/kubernetes-sigs/kui/commit/27d06a1))
- **plugins/plugin-client-common:** allow wizard header to be collapsed ([e8b9c2c](https://github.com/kubernetes-sigs/kui/commit/e8b9c2c))
- **plugins/plugin-client-common:** assign code blocks an ordinal execution order ([c685b94](https://github.com/kubernetes-sigs/kui/commit/c685b94))
- **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** initial support for code block ordering ([adc8beb](https://github.com/kubernetes-sigs/kui/commit/adc8beb))
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- Use patternfly Sidebar to display guidebooks ([d2333e4](https://github.com/kubernetes-sigs/kui/commit/d2333e4))
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)

### Tests

- get rid of test/testv2 distinction (use testv2 impls) ([3f34fee](https://github.com/kubernetes-sigs/kui/commit/3f34fee))

### BREAKING CHANGES

- any clients that relied on old test impls
- this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous

# [11.4.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v11.4.0) (2022-02-25)

### Bug Fixes

- **packages/core:** Events api created and typedoc documentation generated ([531461d](https://github.com/kubernetes-sigs/kui/commit/531461d))
- **packages/core:** Util and Themes APIs added and updated documentation ([b175698](https://github.com/kubernetes-sigs/kui/commit/b175698))
- **packages/test:** tests may fail because active prompt is not in view ([c61f9a5](https://github.com/kubernetes-sigs/kui/commit/c61f9a5))
- **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
- **plugins/plugin-client-common:** markdown mark tags sometimes confused with tabbed ([405201c](https://github.com/kubernetes-sigs/kui/commit/405201c))
- **plugins/plugin-client-common:** markdown with non-tab/tip indentation formats poorly ([7cd9a9e](https://github.com/kubernetes-sigs/kui/commit/7cd9a9e))
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
- tip without title parsing improvements ([d31c2f6](https://github.com/kubernetes-sigs/kui/commit/d31c2f6)), closes [#8417](https://github.com/kubernetes-sigs/kui/issues/8417)
- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)

### chore

- load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)

### Features

- **plugins/plugin-client-common:** allow wizard header to be collapsed ([e8b9c2c](https://github.com/kubernetes-sigs/kui/commit/e8b9c2c))
- improve consistency of input element coloring between guidebooks and plain terminals ([d5bac1d](https://github.com/kubernetes-sigs/kui/commit/d5bac1d))
- **plugins/plugin-client-common:** assign code blocks an ordinal execution order ([c685b94](https://github.com/kubernetes-sigs/kui/commit/c685b94))
- **plugins/plugin-client-common:** initial support for code block ordering ([adc8beb](https://github.com/kubernetes-sigs/kui/commit/adc8beb))
- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- add support for left strip positioning of terminal splits ([a8dc71f](https://github.com/kubernetes-sigs/kui/commit/a8dc71f)), closes [#8202](https://github.com/kubernetes-sigs/kui/issues/8202)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- extend markdown tab syntax to be presented as a Wizard UI ([173e436](https://github.com/kubernetes-sigs/kui/commit/173e436))
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
- Use patternfly Sidebar to display guidebooks ([d2333e4](https://github.com/kubernetes-sigs/kui/commit/d2333e4))
- **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)

### BREAKING CHANGES

- this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous

# [11.3.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v11.3.0) (2022-02-22)

### Bug Fixes

- **packages/core:** Events api created and typedoc documentation generated ([531461d](https://github.com/kubernetes-sigs/kui/commit/531461d))
- **packages/core:** Util and Themes APIs added and updated documentation ([b175698](https://github.com/kubernetes-sigs/kui/commit/b175698))
- **packages/test:** tests may fail because active prompt is not in view ([c61f9a5](https://github.com/kubernetes-sigs/kui/commit/c61f9a5))
- **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
- **plugins/plugin-client-common:** markdown mark tags sometimes confused with tabbed ([405201c](https://github.com/kubernetes-sigs/kui/commit/405201c))
- **plugins/plugin-client-common:** markdown with non-tab/tip indentation formats poorly ([7cd9a9e](https://github.com/kubernetes-sigs/kui/commit/7cd9a9e))
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
- tip without title parsing improvements ([d31c2f6](https://github.com/kubernetes-sigs/kui/commit/d31c2f6)), closes [#8417](https://github.com/kubernetes-sigs/kui/issues/8417)
- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)

### chore

- load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)

### Features

- **plugins/plugin-client-common:** allow wizard header to be collapsed ([e8b9c2c](https://github.com/kubernetes-sigs/kui/commit/e8b9c2c))
- improve consistency of input element coloring between guidebooks and plain terminals ([d5bac1d](https://github.com/kubernetes-sigs/kui/commit/d5bac1d))
- **plugins/plugin-client-common:** assign code blocks an ordinal execution order ([c685b94](https://github.com/kubernetes-sigs/kui/commit/c685b94))
- **plugins/plugin-client-common:** initial support for code block ordering ([adc8beb](https://github.com/kubernetes-sigs/kui/commit/adc8beb))
- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- add support for left strip positioning of terminal splits ([a8dc71f](https://github.com/kubernetes-sigs/kui/commit/a8dc71f)), closes [#8202](https://github.com/kubernetes-sigs/kui/issues/8202)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- extend markdown tab syntax to be presented as a Wizard UI ([173e436](https://github.com/kubernetes-sigs/kui/commit/173e436))
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
- Use patternfly Sidebar to display guidebooks ([d2333e4](https://github.com/kubernetes-sigs/kui/commit/d2333e4))
- **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)

### BREAKING CHANGES

- this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous

# [11.2.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v11.2.0) (2022-02-09)

### Bug Fixes

- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- **plugins/plugin-client-common:** markdown mark tags sometimes confused with tabbed ([405201c](https://github.com/kubernetes-sigs/kui/commit/405201c))
- tip without title parsing improvements ([d31c2f6](https://github.com/kubernetes-sigs/kui/commit/d31c2f6)), closes [#8417](https://github.com/kubernetes-sigs/kui/issues/8417)
- **packages/core:** Events api created and typedoc documentation generated ([531461d](https://github.com/kubernetes-sigs/kui/commit/531461d))
- **packages/core:** Util and Themes APIs added and updated documentation ([b175698](https://github.com/kubernetes-sigs/kui/commit/b175698))
- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)

### chore

- load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)

### Features

- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- add support for left strip positioning of terminal splits ([a8dc71f](https://github.com/kubernetes-sigs/kui/commit/a8dc71f)), closes [#8202](https://github.com/kubernetes-sigs/kui/issues/8202)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- extend markdown tab syntax to be presented as a Wizard UI ([173e436](https://github.com/kubernetes-sigs/kui/commit/173e436))
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- Use patternfly Sidebar to display guidebooks ([d2333e4](https://github.com/kubernetes-sigs/kui/commit/d2333e4))
- **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)

### BREAKING CHANGES

- this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous

# [11.1.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v11.1.0) (2022-01-24)

### Bug Fixes

- tip without title parsing improvements ([d31c2f6](https://github.com/kubernetes-sigs/kui/commit/d31c2f6)), closes [#8417](https://github.com/kubernetes-sigs/kui/issues/8417)
- **packages/core:** Events api created and typedoc documentation generated ([531461d](https://github.com/kubernetes-sigs/kui/commit/531461d))
- **packages/core:** Util and Themes APIs added and updated documentation ([b175698](https://github.com/kubernetes-sigs/kui/commit/b175698))
- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)

### chore

- load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)

### Features

- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- add support for left strip positioning of terminal splits ([a8dc71f](https://github.com/kubernetes-sigs/kui/commit/a8dc71f)), closes [#8202](https://github.com/kubernetes-sigs/kui/issues/8202)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- extend markdown tab syntax to be presented as a Wizard UI ([173e436](https://github.com/kubernetes-sigs/kui/commit/173e436))
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- Use patternfly Sidebar to display guidebooks ([d2333e4](https://github.com/kubernetes-sigs/kui/commit/d2333e4))
- **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)

### BREAKING CHANGES

- this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous

# [11.0.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v11.0.0) (2022-01-18)

### Bug Fixes

- tip without title parsing improvements ([d31c2f6](https://github.com/kubernetes-sigs/kui/commit/d31c2f6)), closes [#8417](https://github.com/kubernetes-sigs/kui/issues/8417)
- **packages/core:** Events api created and typedoc documentation generated ([531461d](https://github.com/kubernetes-sigs/kui/commit/531461d))
- **packages/core:** Util and Themes APIs added and updated documentation ([b175698](https://github.com/kubernetes-sigs/kui/commit/b175698))
- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)

### chore

- load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)

### Features

- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- add support for left strip positioning of terminal splits ([a8dc71f](https://github.com/kubernetes-sigs/kui/commit/a8dc71f)), closes [#8202](https://github.com/kubernetes-sigs/kui/issues/8202)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- Use patternfly Sidebar to display guidebooks ([d2333e4](https://github.com/kubernetes-sigs/kui/commit/d2333e4))
- **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
- When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)

### BREAKING CHANGES

- this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous

# [10.7.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v10.7.0) (2021-10-12)

### Bug Fixes

- notebooks do not open scrolled to top ([d8e697b](https://github.com/kubernetes-sigs/kui/commit/d8e697b)), closes [#8152](https://github.com/kubernetes-sigs/kui/issues/8152) [#8151](https://github.com/kubernetes-sigs/kui/issues/8151)
- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
- **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)

### chore

- load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)

### Features

- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- bottom strip UI and StatusModel UI ([0721ec5](https://github.com/kubernetes-sigs/kui/commit/0721ec5)), closes [#8123](https://github.com/kubernetes-sigs/kui/issues/8123)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
- **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
- When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)

### BREAKING CHANGES

- this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous

# [10.6.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v10.6.0) (2021-09-27)

### Bug Fixes

- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)

### chore

- load-time tuning ([1a9b10e](https://github.com/kubernetes-sigs/kui/commit/1a9b10e)), closes [#8070](https://github.com/kubernetes-sigs/kui/issues/8070)

### Features

- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- support for Description List UIs ([81050b1](https://github.com/kubernetes-sigs/kui/commit/81050b1)), closes [#8058](https://github.com/kubernetes-sigs/kui/issues/8058)
- **plugins/plugin-client-common:** Editor component should default to a fold depth of 2 ([b0ca4e7](https://github.com/kubernetes-sigs/kui/commit/b0ca4e7)), closes [#8008](https://github.com/kubernetes-sigs/kui/issues/8008)
- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)

### BREAKING CHANGES

- this alters the loading cycle in a way that may break sensitive tests, mostly by making certain actions a bit more asynchronous

# [10.5.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v10.5.0) (2021-09-13)

### Bug Fixes

- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **plugins/plugin-client-common:** Change block rerun action button from Retry icon to Play icon ([1e74b8f](https://github.com/kubernetes-sigs/kui/commit/1e74b8f)), closes [#7696](https://github.com/kubernetes-sigs/kui/issues/7696)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- **plugins/plugin-client-common:** React dev warning for Input ([cf923c1](https://github.com/kubernetes-sigs/kui/commit/cf923c1)), closes [#7911](https://github.com/kubernetes-sigs/kui/issues/7911)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-client-common:** snapshot doesn't preserve cancelled or empty block ([2300d65](https://github.com/kubernetes-sigs/kui/commit/2300d65))
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)

### Features

- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- link the accomplishment of a block to commentary ([a8c4f2c](https://github.com/kubernetes-sigs/kui/commit/a8c4f2c))
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- section blocks ([8e79cf4](https://github.com/kubernetes-sigs/kui/commit/8e79cf4))
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- When replaying a notebook, prior output should have an ExpandableSection wrapper ([5ed76ae](https://github.com/kubernetes-sigs/kui/commit/5ed76ae)), closes [#7846](https://github.com/kubernetes-sigs/kui/issues/7846)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)

# [10.4.0](https://github.com/kubernetes-sigs/kui/compare/v4.5.0...v10.4.0) (2021-06-17)

### Bug Fixes

- Bottom Input clients do not support splits ([303db45](https://github.com/kubernetes-sigs/kui/commit/303db45)), closes [#7512](https://github.com/kubernetes-sigs/kui/issues/7512)
- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/kubernetes-sigs/kui/commit/8c8d76e)), closes [#6887](https://github.com/kubernetes-sigs/kui/issues/6887)
- **plugins/plugin-client-common:** improve the error-handling of grammy parsing histogram data ([8758f8d](https://github.com/kubernetes-sigs/kui/commit/8758f8d)), closes [#7177](https://github.com/kubernetes-sigs/kui/issues/7177)
- **plugins/plugin-client-common:** sidecar Kebab menu has nested <button> ([8bcf21d](https://github.com/kubernetes-sigs/kui/commit/8bcf21d))
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/kubernetes-sigs/kui/commit/79e7df3)), closes [#6913](https://github.com/kubernetes-sigs/kui/issues/6913)
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/kubernetes-sigs/kui/commit/d5a9c3a)), closes [#6792](https://github.com/kubernetes-sigs/kui/issues/6792)
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/kubernetes-sigs/kui/commit/f8486f8)), closes [#5629](https://github.com/kubernetes-sigs/kui/issues/5629)
- about should show breadcrumbs ([99dc401](https://github.com/kubernetes-sigs/kui/commit/99dc401)), closes [#4730](https://github.com/kubernetes-sigs/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/kubernetes-sigs/kui/commit/5450512)), closes [#4640](https://github.com/kubernetes-sigs/kui/issues/4640) [#4655](https://github.com/kubernetes-sigs/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/kubernetes-sigs/kui/commit/0b10599)), closes [#3217](https://github.com/kubernetes-sigs/kui/issues/3217)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/kubernetes-sigs/kui/commit/80192d5)), closes [#6001](https://github.com/kubernetes-sigs/kui/issues/6001)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/kubernetes-sigs/kui/commit/00e2728)), closes [#3777](https://github.com/kubernetes-sigs/kui/issues/3777)
- improve alignment of icons ([221d0f9](https://github.com/kubernetes-sigs/kui/commit/221d0f9)), closes [#4555](https://github.com/kubernetes-sigs/kui/issues/4555)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/kubernetes-sigs/kui/commit/470da34)), closes [#5604](https://github.com/kubernetes-sigs/kui/issues/5604)
- improve windows build support ([cacd68b](https://github.com/kubernetes-sigs/kui/commit/cacd68b)), closes [#3332](https://github.com/kubernetes-sigs/kui/issues/3332)
- improved support for replaying splits ([8039a9d](https://github.com/kubernetes-sigs/kui/commit/8039a9d)), closes [#5535](https://github.com/kubernetes-sigs/kui/issues/5535)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/kubernetes-sigs/kui/commit/31361ec)), closes [#6778](https://github.com/kubernetes-sigs/kui/issues/6778)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/kubernetes-sigs/kui/commit/8bf8ebe)), closes [#6114](https://github.com/kubernetes-sigs/kui/issues/6114)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/kubernetes-sigs/kui/commit/5e28860)), closes [#6636](https://github.com/kubernetes-sigs/kui/issues/6636)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/kubernetes-sigs/kui/commit/49bfbcc)), closes [#4855](https://github.com/kubernetes-sigs/kui/issues/4855)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/kubernetes-sigs/kui/commit/4cc16be)), closes [#5176](https://github.com/kubernetes-sigs/kui/issues/5176)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/kubernetes-sigs/kui/commit/3c14da5)), closes [#4945](https://github.com/kubernetes-sigs/kui/issues/4945)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/kubernetes-sigs/kui/commit/be04d20)), closes [#4767](https://github.com/kubernetes-sigs/kui/issues/4767)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/kubernetes-sigs/kui/commit/fbeae76)), closes [#2771](https://github.com/kubernetes-sigs/kui/issues/2771)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/kubernetes-sigs/kui/commit/cf5e41f)), closes [#4666](https://github.com/kubernetes-sigs/kui/issues/4666)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/kubernetes-sigs/kui/commit/8fbdce5)), closes [#4487](https://github.com/kubernetes-sigs/kui/issues/4487)
- improve error reporting for kubectl apply ([fe21671](https://github.com/kubernetes-sigs/kui/commit/fe21671)), closes [#4605](https://github.com/kubernetes-sigs/kui/issues/4605)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/kubernetes-sigs/kui/commit/50ced8f)), closes [#4896](https://github.com/kubernetes-sigs/kui/issues/4896)
- Input element throws react error ([e6bb21b](https://github.com/kubernetes-sigs/kui/commit/e6bb21b)), closes [#4765](https://github.com/kubernetes-sigs/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/kubernetes-sigs/kui/commit/e740270)), closes [#4626](https://github.com/kubernetes-sigs/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/kubernetes-sigs/kui/commit/1976134)), closes [#4797](https://github.com/kubernetes-sigs/kui/issues/4797)
- multiple command history regressions ([cbba96c](https://github.com/kubernetes-sigs/kui/commit/cbba96c)), closes [#5283](https://github.com/kubernetes-sigs/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/kubernetes-sigs/kui/commit/a09138d)), closes [#3949](https://github.com/kubernetes-sigs/kui/issues/3949)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/kubernetes-sigs/kui/commit/56f69cb)), closes [#5024](https://github.com/kubernetes-sigs/kui/issues/5024)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/kubernetes-sigs/kui/commit/f160337)), closes [#3449](https://github.com/kubernetes-sigs/kui/issues/3449)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/kubernetes-sigs/kui/commit/1e296c7)), closes [#4300](https://github.com/kubernetes-sigs/kui/issues/4300)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/kubernetes-sigs/kui/commit/e539a53)), closes [#6581](https://github.com/kubernetes-sigs/kui/issues/6581) [#6328](https://github.com/kubernetes-sigs/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/kubernetes-sigs/kui/commit/128ec92)), closes [#5495](https://github.com/kubernetes-sigs/kui/issues/5495)
- return an NavResponse without links results in blank page ([e684344](https://github.com/kubernetes-sigs/kui/commit/e684344)), closes [#3927](https://github.com/kubernetes-sigs/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/kubernetes-sigs/kui/commit/fba613a)), closes [#4746](https://github.com/kubernetes-sigs/kui/issues/4746)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/kubernetes-sigs/kui/commit/8d4cf8c)), closes [#5730](https://github.com/kubernetes-sigs/kui/issues/5730)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/kubernetes-sigs/kui/commit/e67e0c9)), closes [#4789](https://github.com/kubernetes-sigs/kui/issues/4789)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/kubernetes-sigs/kui/commit/51a2aad)), closes [#6014](https://github.com/kubernetes-sigs/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/kubernetes-sigs/kui/commit/8f9dc23)), closes [#5626](https://github.com/kubernetes-sigs/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/kubernetes-sigs/kui/commit/006b881)), closes [#6293](https://github.com/kubernetes-sigs/kui/issues/6293)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/kubernetes-sigs/kui/commit/244b16a)), closes [#6539](https://github.com/kubernetes-sigs/kui/issues/6539)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/kubernetes-sigs/kui/commit/91cd2cc)), closes [#3164](https://github.com/kubernetes-sigs/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/kubernetes-sigs/kui/commit/5ce89aa)), closes [#3589](https://github.com/kubernetes-sigs/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/kubernetes-sigs/kui/commit/07aa3e3)), closes [#3172](https://github.com/kubernetes-sigs/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/kubernetes-sigs/kui/commit/5c996f4)), closes [#3246](https://github.com/kubernetes-sigs/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/kubernetes-sigs/kui/commit/89578dc)), closes [#3106](https://github.com/kubernetes-sigs/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/kubernetes-sigs/kui/commit/14fcdc9)), closes [#3407](https://github.com/kubernetes-sigs/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/kubernetes-sigs/kui/commit/2f95129)), closes [#4466](https://github.com/kubernetes-sigs/kui/issues/4466)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/kubernetes-sigs/kui/commit/fbe367c)), closes [#5434](https://github.com/kubernetes-sigs/kui/issues/5434)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/kubernetes-sigs/kui/commit/486a02e)), closes [#6134](https://github.com/kubernetes-sigs/kui/issues/6134)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/kubernetes-sigs/kui/commit/d1aa46d)), closes [#5285](https://github.com/kubernetes-sigs/kui/issues/5285)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/kubernetes-sigs/kui/commit/24d074f)), closes [#3643](https://github.com/kubernetes-sigs/kui/issues/3643)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/kubernetes-sigs/kui/commit/fd1b3a1)), closes [#6477](https://github.com/kubernetes-sigs/kui/issues/6477)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/kubernetes-sigs/kui/commit/20f0737)), closes [#6517](https://github.com/kubernetes-sigs/kui/issues/6517)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/kubernetes-sigs/kui/commit/14c27ba)), closes [#4229](https://github.com/kubernetes-sigs/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/kubernetes-sigs/kui/commit/ef887f4)), closes [#3969](https://github.com/kubernetes-sigs/kui/issues/3969)

### Features

- add events to sidecar tree ([dd4d552](https://github.com/kubernetes-sigs/kui/commit/dd4d552)), closes [#6140](https://github.com/kubernetes-sigs/kui/issues/6140)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/kubernetes-sigs/kui/commit/85ea2d5)), closes [#6132](https://github.com/kubernetes-sigs/kui/issues/6132)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/kubernetes-sigs/kui/commit/eb9f147)), closes [#5282](https://github.com/kubernetes-sigs/kui/issues/5282)
- background new tabs ([be9f986](https://github.com/kubernetes-sigs/kui/commit/be9f986)), closes [#5550](https://github.com/kubernetes-sigs/kui/issues/5550)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/kubernetes-sigs/kui/commit/3a199c7)), closes [#6348](https://github.com/kubernetes-sigs/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/kubernetes-sigs/kui/commit/fd780df)), closes [#5525](https://github.com/kubernetes-sigs/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/kubernetes-sigs/kui/commit/b0b95cf)), closes [#5879](https://github.com/kubernetes-sigs/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/kubernetes-sigs/kui/commit/8df1ad3)), closes [#6504](https://github.com/kubernetes-sigs/kui/issues/6504)
- generalized kuberctl get with limit ([d40ee07](https://github.com/kubernetes-sigs/kui/commit/d40ee07)), closes [#5361](https://github.com/kubernetes-sigs/kui/issues/5361)
- head command against vfs ([03e3f8a](https://github.com/kubernetes-sigs/kui/commit/03e3f8a)), closes [#7012](https://github.com/kubernetes-sigs/kui/issues/7012)
- improve repl-block selection ([305b36f](https://github.com/kubernetes-sigs/kui/commit/305b36f)), closes [#5587](https://github.com/kubernetes-sigs/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/kubernetes-sigs/kui/commit/5744bf4)), closes [#5513](https://github.com/kubernetes-sigs/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/kubernetes-sigs/kui/commit/47b26be)), closes [#6440](https://github.com/kubernetes-sigs/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/kubernetes-sigs/kui/commit/2c3afeb)), closes [#6007](https://github.com/kubernetes-sigs/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/kubernetes-sigs/kui/commit/fe80525)), closes [#6026](https://github.com/kubernetes-sigs/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/kubernetes-sigs/kui/commit/38d2895)), closes [#5537](https://github.com/kubernetes-sigs/kui/issues/5537)
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/kubernetes-sigs/kui/commit/fb89c29)), closes [#6403](https://github.com/kubernetes-sigs/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/kubernetes-sigs/kui/commit/b9c5867)), closes [#6109](https://github.com/kubernetes-sigs/kui/issues/6109)
- pass command line comments to commentary command ([a020db5](https://github.com/kubernetes-sigs/kui/commit/a020db5)), closes [#5459](https://github.com/kubernetes-sigs/kui/issues/5459)
- pause and resume watchable jobs ([5d3f719](https://github.com/kubernetes-sigs/kui/commit/5d3f719)), closes [#1747](https://github.com/kubernetes-sigs/kui/issues/1747)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/kubernetes-sigs/kui/commit/a2efb8a)), closes [#5399](https://github.com/kubernetes-sigs/kui/issues/5399)
- save/restore pty command output ([2c291a9](https://github.com/kubernetes-sigs/kui/commit/2c291a9)), closes [#5314](https://github.com/kubernetes-sigs/kui/issues/5314)
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/kubernetes-sigs/kui/commit/e10f7f2)), closes [#6856](https://github.com/kubernetes-sigs/kui/issues/6856)
- SplitHeader should have a clear button ([7d4456b](https://github.com/kubernetes-sigs/kui/commit/7d4456b))
- use Accordion for SourceRef ([1b11736](https://github.com/kubernetes-sigs/kui/commit/1b11736)), closes [#6097](https://github.com/kubernetes-sigs/kui/issues/6097)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/kubernetes-sigs/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/kubernetes-sigs/kui/commit/0f7648c)), closes [#6351](https://github.com/kubernetes-sigs/kui/issues/6351)
- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/kubernetes-sigs/kui/commit/0e1c25e)), closes [#6920](https://github.com/kubernetes-sigs/kui/issues/6920)
- view table as histogram ([503c10a](https://github.com/kubernetes-sigs/kui/commit/503c10a)), closes [#7138](https://github.com/kubernetes-sigs/kui/issues/7138)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/kubernetes-sigs/kui/commit/c5384e0)), closes [#4570](https://github.com/kubernetes-sigs/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/kubernetes-sigs/kui/commit/e935092)), closes [#5576](https://github.com/kubernetes-sigs/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/kubernetes-sigs/kui/commit/f7f6918)), closes [#5589](https://github.com/kubernetes-sigs/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/kubernetes-sigs/kui/commit/a72cf8d)), closes [#5752](https://github.com/kubernetes-sigs/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/kubernetes-sigs/kui/commit/6d828c1)), closes [#5664](https://github.com/kubernetes-sigs/kui/issues/5664)
- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/kubernetes-sigs/kui/commit/f7ccdf1)), closes [#6867](https://github.com/kubernetes-sigs/kui/issues/6867)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/kubernetes-sigs/kui/commit/1f544b5)), closes [#5667](https://github.com/kubernetes-sigs/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/kubernetes-sigs/kui/commit/791160e)), closes [#5472](https://github.com/kubernetes-sigs/kui/issues/5472)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/kubernetes-sigs/kui/commit/1e2fb41)), closes [#5342](https://github.com/kubernetes-sigs/kui/issues/5342)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/kubernetes-sigs/kui/commit/75857e9)), closes [#5746](https://github.com/kubernetes-sigs/kui/issues/5746)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/kubernetes-sigs/kui/commit/e9028ee)), closes [#5336](https://github.com/kubernetes-sigs/kui/issues/5336)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/kubernetes-sigs/kui/commit/677faca)), closes [#5302](https://github.com/kubernetes-sigs/kui/issues/5302) [#5303](https://github.com/kubernetes-sigs/kui/issues/5303)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/kubernetes-sigs/kui/commit/dc22591)), closes [#4530](https://github.com/kubernetes-sigs/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/kubernetes-sigs/kui/commit/0c33e6e)), closes [#4990](https://github.com/kubernetes-sigs/kui/issues/4990) [#5007](https://github.com/kubernetes-sigs/kui/issues/5007)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/kubernetes-sigs/kui/commit/09043c1)), closes [#4554](https://github.com/kubernetes-sigs/kui/issues/4554)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/kubernetes-sigs/kui/commit/f4ba8e6)), closes [#5278](https://github.com/kubernetes-sigs/kui/issues/5278)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/kubernetes-sigs/kui/commit/59a9213)), closes [#5256](https://github.com/kubernetes-sigs/kui/issues/5256)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/kubernetes-sigs/kui/commit/d8d13ab)), closes [#4973](https://github.com/kubernetes-sigs/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/kubernetes-sigs/kui/commit/495d3bb)), closes [#4957](https://github.com/kubernetes-sigs/kui/issues/4957)
- add history to sidecar views ([b1e5543](https://github.com/kubernetes-sigs/kui/commit/b1e5543)), closes [#3960](https://github.com/kubernetes-sigs/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/kubernetes-sigs/kui/commit/95f731d)), closes [#4041](https://github.com/kubernetes-sigs/kui/issues/4041) [#4040](https://github.com/kubernetes-sigs/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/kubernetes-sigs/kui/commit/80ea40f)), closes [#4106](https://github.com/kubernetes-sigs/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/kubernetes-sigs/kui/commit/237e9a5)), closes [#3632](https://github.com/kubernetes-sigs/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/kubernetes-sigs/kui/commit/c6dc99f)), closes [#5173](https://github.com/kubernetes-sigs/kui/issues/5173)
- client test ([4c16985](https://github.com/kubernetes-sigs/kui/commit/4c16985)), closes [#3130](https://github.com/kubernetes-sigs/kui/issues/3130)
- command history should be tab-specific ([1b987e0](https://github.com/kubernetes-sigs/kui/commit/1b987e0)), closes [#1299](https://github.com/kubernetes-sigs/kui/issues/1299)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/kubernetes-sigs/kui/commit/4814cb9)), closes [#2935](https://github.com/kubernetes-sigs/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/kubernetes-sigs/kui/commit/08062e9)), closes [#1456](https://github.com/kubernetes-sigs/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/kubernetes-sigs/kui/commit/414e813)), closes [#762](https://github.com/kubernetes-sigs/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/kubernetes-sigs/kui/commit/06eec95)), closes [#4127](https://github.com/kubernetes-sigs/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/kubernetes-sigs/kui/commit/f88329e)), closes [#3635](https://github.com/kubernetes-sigs/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/kubernetes-sigs/kui/commit/70b8441)), closes [#5112](https://github.com/kubernetes-sigs/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/kubernetes-sigs/kui/commit/d25f7a0)), closes [#3608](https://github.com/kubernetes-sigs/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/kubernetes-sigs/kui/commit/1886e58)), closes [#3451](https://github.com/kubernetes-sigs/kui/issues/3451)
- split screen Terminal ([3a6b422](https://github.com/kubernetes-sigs/kui/commit/3a6b422)), closes [#4814](https://github.com/kubernetes-sigs/kui/issues/4814) [#4821](https://github.com/kubernetes-sigs/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/kubernetes-sigs/kui/commit/51669af)), closes [#5115](https://github.com/kubernetes-sigs/kui/issues/5115)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/kubernetes-sigs/kui/commit/d4f6984)), closes [#4909](https://github.com/kubernetes-sigs/kui/issues/4909)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/kubernetes-sigs/kui/commit/f94a22f)), closes [#6136](https://github.com/kubernetes-sigs/kui/issues/6136)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/kubernetes-sigs/kui/commit/662f413)), closes [#4865](https://github.com/kubernetes-sigs/kui/issues/4865) [#4573](https://github.com/kubernetes-sigs/kui/issues/4573) [#4885](https://github.com/kubernetes-sigs/kui/issues/4885) [#4894](https://github.com/kubernetes-sigs/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/kubernetes-sigs/kui/commit/be0eabf)), closes [#4510](https://github.com/kubernetes-sigs/kui/issues/4510) [#4511](https://github.com/kubernetes-sigs/kui/issues/4511)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/kubernetes-sigs/kui/commit/f1d8d98)), closes [#3902](https://github.com/kubernetes-sigs/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/kubernetes-sigs/kui/commit/d88436e)), closes [#4014](https://github.com/kubernetes-sigs/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/kubernetes-sigs/kui/commit/41bf5cf)), closes [#4161](https://github.com/kubernetes-sigs/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/kubernetes-sigs/kui/commit/c1ed680)), closes [#2431](https://github.com/kubernetes-sigs/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/kubernetes-sigs/kui/commit/a20e289)), closes [#3793](https://github.com/kubernetes-sigs/kui/issues/3793)
- support replaying in new tab ([04a2c67](https://github.com/kubernetes-sigs/kui/commit/04a2c67)), closes [#5509](https://github.com/kubernetes-sigs/kui/issues/5509)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/kubernetes-sigs/kui/commit/409e632)), closes [#4762](https://github.com/kubernetes-sigs/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/kubernetes-sigs/kui/commit/ff8cfba)), closes [#4434](https://github.com/kubernetes-sigs/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/kubernetes-sigs/kui/commit/5a4611e)), closes [#4043](https://github.com/kubernetes-sigs/kui/issues/4043) [#3657](https://github.com/kubernetes-sigs/kui/issues/3657) [#4044](https://github.com/kubernetes-sigs/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/kubernetes-sigs/kui/commit/6dfe7df)), closes [#4503](https://github.com/kubernetes-sigs/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/kubernetes-sigs/kui/commit/54d727a)), closes [#3189](https://github.com/kubernetes-sigs/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/kubernetes-sigs/kui/commit/6bfb255)), closes [#3295](https://github.com/kubernetes-sigs/kui/issues/3295)

# [10.2.0](https://github.com/IBM/kui/compare/v10.1.1-dev-20210223-062039...v10.2.0) (2021-02-24)

**Note:** Version bump only for package @kui-shell/test

## [10.1.1-dev-20210223-062039](https://github.com/IBM/kui/compare/v10.1.1-dev-20210221-141404...v10.1.1-dev-20210223-062039) (2021-02-23)

**Note:** Version bump only for package @kui-shell/test

## [10.1.1-dev-20210221-141404](https://github.com/IBM/kui/compare/v10.1.1-dev-20210219-194602...v10.1.1-dev-20210221-141404) (2021-02-21)

**Note:** Version bump only for package @kui-shell/test

## [10.1.1-dev-20210219-194602](https://github.com/IBM/kui/compare/v10.1.1-dev-20210218-202429...v10.1.1-dev-20210219-194602) (2021-02-20)

**Note:** Version bump only for package @kui-shell/test

## [10.1.1-dev-20210218-202429](https://github.com/IBM/kui/compare/v10.1.1-dev-20210218-164854...v10.1.1-dev-20210218-202429) (2021-02-19)

**Note:** Version bump only for package @kui-shell/test

## [10.1.1-dev-20210218-164854](https://github.com/IBM/kui/compare/v10.1.1-dev-20210218-131731...v10.1.1-dev-20210218-164854) (2021-02-18)

**Note:** Version bump only for package @kui-shell/test

## [10.1.1-dev-20210218-131731](https://github.com/IBM/kui/compare/v10.1.1-dev-20210216-094031...v10.1.1-dev-20210218-131731) (2021-02-18)

### Features

- use Select Component for Kubernetes Context and Namespace status stripe widgets ([0e1c25e](https://github.com/IBM/kui/commit/0e1c25e)), closes [#6920](https://github.com/IBM/kui/issues/6920)

## [10.1.1-dev-20210216-094031](https://github.com/IBM/kui/compare/v10.1.1-dev-20210215-213847...v10.1.1-dev-20210216-094031) (2021-02-16)

**Note:** Version bump only for package @kui-shell/test

## [10.1.1-dev-20210215-213847](https://github.com/IBM/kui/compare/v10.1.1-dev-20210215-184959...v10.1.1-dev-20210215-213847) (2021-02-16)

**Note:** Version bump only for package @kui-shell/test

## [10.1.1-dev-20210215-184959](https://github.com/IBM/kui/compare/v10.1.1-dev-20210215-161454...v10.1.1-dev-20210215-184959) (2021-02-15)

**Note:** Version bump only for package @kui-shell/test

## [10.1.1-dev-20210215-161454](https://github.com/IBM/kui/compare/v10.1.1-dev-20210211-145439...v10.1.1-dev-20210215-161454) (2021-02-15)

### Features

- head command against vfs ([03e3f8a](https://github.com/IBM/kui/commit/03e3f8a)), closes [#7012](https://github.com/IBM/kui/issues/7012)

## [10.1.1-dev-20210211-145439](https://github.com/IBM/kui/compare/v4.5.0...v10.1.1-dev-20210211-145439) (2021-02-11)

### Bug Fixes

- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/IBM/kui/commit/8c8d76e)), closes [#6887](https://github.com/IBM/kui/issues/6887)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/IBM/kui/commit/486a02e)), closes [#6134](https://github.com/IBM/kui/issues/6134)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/IBM/kui/commit/fd1b3a1)), closes [#6477](https://github.com/IBM/kui/issues/6477)
- **plugins/plugin-client-common:** Sidecar sticks to a short height when switching from Yaml -> Summary -> Yaml tab ([79e7df3](https://github.com/IBM/kui/commit/79e7df3)), closes [#6913](https://github.com/IBM/kui/issues/6913)
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/IBM/kui/commit/d5a9c3a)), closes [#6792](https://github.com/IBM/kui/issues/6792)
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/IBM/kui/commit/f8486f8)), closes [#5629](https://github.com/IBM/kui/issues/5629)
- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/IBM/kui/commit/50ced8f)), closes [#4896](https://github.com/IBM/kui/issues/4896)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/IBM/kui/commit/31361ec)), closes [#6778](https://github.com/IBM/kui/issues/6778)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/IBM/kui/commit/5e28860)), closes [#6636](https://github.com/IBM/kui/issues/6636)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/IBM/kui/commit/fbeae76)), closes [#2771](https://github.com/IBM/kui/issues/2771)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/IBM/kui/commit/80192d5)), closes [#6001](https://github.com/IBM/kui/issues/6001)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/IBM/kui/commit/470da34)), closes [#5604](https://github.com/IBM/kui/issues/5604)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- improved support for replaying splits ([8039a9d](https://github.com/IBM/kui/commit/8039a9d)), closes [#5535](https://github.com/IBM/kui/issues/5535)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/IBM/kui/commit/8bf8ebe)), closes [#6114](https://github.com/IBM/kui/issues/6114)
- multiple command history regressions ([cbba96c](https://github.com/IBM/kui/commit/cbba96c)), closes [#5283](https://github.com/IBM/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/IBM/kui/commit/e539a53)), closes [#6581](https://github.com/IBM/kui/issues/6581) [#6328](https://github.com/IBM/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/IBM/kui/commit/128ec92)), closes [#5495](https://github.com/IBM/kui/issues/5495)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/IBM/kui/commit/8d4cf8c)), closes [#5730](https://github.com/IBM/kui/issues/5730)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/IBM/kui/commit/51a2aad)), closes [#6014](https://github.com/IBM/kui/issues/6014)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/IBM/kui/commit/244b16a)), closes [#6539](https://github.com/IBM/kui/issues/6539)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/IBM/kui/commit/20f0737)), closes [#6517](https://github.com/IBM/kui/issues/6517)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/IBM/kui/commit/8f9dc23)), closes [#5626](https://github.com/IBM/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/IBM/kui/commit/006b881)), closes [#6293](https://github.com/IBM/kui/issues/6293)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/IBM/kui/commit/fbe367c)), closes [#5434](https://github.com/IBM/kui/issues/5434)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/IBM/kui/commit/49bfbcc)), closes [#4855](https://github.com/IBM/kui/issues/4855)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/IBM/kui/commit/d1aa46d)), closes [#5285](https://github.com/IBM/kui/issues/5285)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/IBM/kui/commit/4cc16be)), closes [#5176](https://github.com/IBM/kui/issues/5176)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/IBM/kui/commit/56f69cb)), closes [#5024](https://github.com/IBM/kui/issues/5024)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/IBM/kui/commit/3c14da5)), closes [#4945](https://github.com/IBM/kui/issues/4945)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)

### Features

- **plugins/plugin-client-common:** empty tables use PatternFly's "empty state" UI ([f7ccdf1](https://github.com/IBM/kui/commit/f7ccdf1)), closes [#6867](https://github.com/IBM/kui/issues/6867)
- add events to sidecar tree ([dd4d552](https://github.com/IBM/kui/commit/dd4d552)), closes [#6140](https://github.com/IBM/kui/issues/6140)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/IBM/kui/commit/e9028ee)), closes [#5336](https://github.com/IBM/kui/issues/5336)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/IBM/kui/commit/85ea2d5)), closes [#6132](https://github.com/IBM/kui/issues/6132)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/IBM/kui/commit/eb9f147)), closes [#5282](https://github.com/IBM/kui/issues/5282)
- background new tabs ([be9f986](https://github.com/IBM/kui/commit/be9f986)), closes [#5550](https://github.com/IBM/kui/issues/5550)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/IBM/kui/commit/3a199c7)), closes [#6348](https://github.com/IBM/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/IBM/kui/commit/fd780df)), closes [#5525](https://github.com/IBM/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/IBM/kui/commit/b0b95cf)), closes [#5879](https://github.com/IBM/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/IBM/kui/commit/8df1ad3)), closes [#6504](https://github.com/IBM/kui/issues/6504)
- generalized kuberctl get with limit ([d40ee07](https://github.com/IBM/kui/commit/d40ee07)), closes [#5361](https://github.com/IBM/kui/issues/5361)
- improve repl-block selection ([305b36f](https://github.com/IBM/kui/commit/305b36f)), closes [#5587](https://github.com/IBM/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/IBM/kui/commit/5744bf4)), closes [#5513](https://github.com/IBM/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/IBM/kui/commit/47b26be)), closes [#6440](https://github.com/IBM/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/IBM/kui/commit/2c3afeb)), closes [#6007](https://github.com/IBM/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/IBM/kui/commit/fe80525)), closes [#6026](https://github.com/IBM/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/IBM/kui/commit/38d2895)), closes [#5537](https://github.com/IBM/kui/issues/5537)
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/IBM/kui/commit/fb89c29)), closes [#6403](https://github.com/IBM/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/IBM/kui/commit/b9c5867)), closes [#6109](https://github.com/IBM/kui/issues/6109)
- pass command line comments to commentary command ([a020db5](https://github.com/IBM/kui/commit/a020db5)), closes [#5459](https://github.com/IBM/kui/issues/5459)
- pause and resume watchable jobs ([5d3f719](https://github.com/IBM/kui/commit/5d3f719)), closes [#1747](https://github.com/IBM/kui/issues/1747)
- preserve changes of table view state in Notebook ([a2efb8a](https://github.com/IBM/kui/commit/a2efb8a)), closes [#5399](https://github.com/IBM/kui/issues/5399)
- save/restore pty command output ([2c291a9](https://github.com/IBM/kui/commit/2c291a9)), closes [#5314](https://github.com/IBM/kui/issues/5314)
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/IBM/kui/commit/e10f7f2)), closes [#6856](https://github.com/IBM/kui/issues/6856)
- use Accordion for SourceRef ([1b11736](https://github.com/IBM/kui/commit/1b11736)), closes [#6097](https://github.com/IBM/kui/issues/6097)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/IBM/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/IBM/kui/commit/0f7648c)), closes [#6351](https://github.com/IBM/kui/issues/6351)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/IBM/kui/commit/c5384e0)), closes [#4570](https://github.com/IBM/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/IBM/kui/commit/e935092)), closes [#5576](https://github.com/IBM/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/IBM/kui/commit/f7f6918)), closes [#5589](https://github.com/IBM/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/IBM/kui/commit/a72cf8d)), closes [#5752](https://github.com/IBM/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/IBM/kui/commit/6d828c1)), closes [#5664](https://github.com/IBM/kui/issues/5664)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/IBM/kui/commit/1f544b5)), closes [#5667](https://github.com/IBM/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/IBM/kui/commit/791160e)), closes [#5472](https://github.com/IBM/kui/issues/5472)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/IBM/kui/commit/1e2fb41)), closes [#5342](https://github.com/IBM/kui/issues/5342)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/IBM/kui/commit/75857e9)), closes [#5746](https://github.com/IBM/kui/issues/5746)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/IBM/kui/commit/f4ba8e6)), closes [#5278](https://github.com/IBM/kui/issues/5278)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/IBM/kui/commit/59a9213)), closes [#5256](https://github.com/IBM/kui/issues/5256)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/IBM/kui/commit/d8d13ab)), closes [#4973](https://github.com/IBM/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/IBM/kui/commit/495d3bb)), closes [#4957](https://github.com/IBM/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/IBM/kui/commit/0c33e6e)), closes [#4990](https://github.com/IBM/kui/issues/4990) [#5007](https://github.com/IBM/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/IBM/kui/commit/c6dc99f)), closes [#5173](https://github.com/IBM/kui/issues/5173)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- command history should be tab-specific ([1b987e0](https://github.com/IBM/kui/commit/1b987e0)), closes [#1299](https://github.com/IBM/kui/issues/1299)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/IBM/kui/commit/70b8441)), closes [#5112](https://github.com/IBM/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/IBM/kui/commit/662f413)), closes [#4865](https://github.com/IBM/kui/issues/4865) [#4573](https://github.com/IBM/kui/issues/4573) [#4885](https://github.com/IBM/kui/issues/4885) [#4894](https://github.com/IBM/kui/issues/4894)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- support for events in table footer ([51669af](https://github.com/IBM/kui/commit/51669af)), closes [#5115](https://github.com/IBM/kui/issues/5115)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/IBM/kui/commit/d4f6984)), closes [#4909](https://github.com/IBM/kui/issues/4909)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/IBM/kui/commit/677faca)), closes [#5302](https://github.com/IBM/kui/issues/5302) [#5303](https://github.com/IBM/kui/issues/5303)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/IBM/kui/commit/f94a22f)), closes [#6136](https://github.com/IBM/kui/issues/6136)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- support replaying in new tab ([04a2c67](https://github.com/IBM/kui/commit/04a2c67)), closes [#5509](https://github.com/IBM/kui/issues/5509)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

## [10.0.1](https://github.com/IBM/kui/compare/v4.5.0...v10.0.1) (2021-02-01)

### Bug Fixes

- **packages/test:** test selector for ACTIVATION_TITLE expects it to be clickable ([8c8d76e](https://github.com/IBM/kui/commit/8c8d76e)), closes [#6887](https://github.com/IBM/kui/issues/6887)
- **plugins/plugin-client-common:** Table onclick handlers applied to every cell ([d5a9c3a](https://github.com/IBM/kui/commit/d5a9c3a)), closes [#6792](https://github.com/IBM/kui/issues/6792)
- kubectl direct/get does not specify that get tables have the `onclickIdempotent` property ([31361ec](https://github.com/IBM/kui/commit/31361ec)), closes [#6778](https://github.com/IBM/kui/issues/6778)
- kubectl Terminal tab test is flakey ([5e28860](https://github.com/IBM/kui/commit/5e28860)), closes [#6636](https://github.com/IBM/kui/issues/6636)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/IBM/kui/commit/486a02e)), closes [#6134](https://github.com/IBM/kui/issues/6134)
- **plugins/plugin-client-common:** show table click result in a new split ([fd1b3a1](https://github.com/IBM/kui/commit/fd1b3a1)), closes [#6477](https://github.com/IBM/kui/issues/6477)
- **plugins/plugin-kubectl:** events watching returns an empty table with just a streaming events footer ([fbeae76](https://github.com/IBM/kui/commit/fbeae76)), closes [#2771](https://github.com/IBM/kui/issues/2771)
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/IBM/kui/commit/f8486f8)), closes [#5629](https://github.com/IBM/kui/issues/5629)
- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/IBM/kui/commit/80192d5)), closes [#6001](https://github.com/IBM/kui/issues/6001)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/IBM/kui/commit/50ced8f)), closes [#4896](https://github.com/IBM/kui/issues/4896)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/IBM/kui/commit/470da34)), closes [#5604](https://github.com/IBM/kui/issues/5604)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- improved support for replaying splits ([8039a9d](https://github.com/IBM/kui/commit/8039a9d)), closes [#5535](https://github.com/IBM/kui/issues/5535)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- kubectl kustomize can have bogus output ([8bf8ebe](https://github.com/IBM/kui/commit/8bf8ebe)), closes [#6114](https://github.com/IBM/kui/issues/6114)
- multiple command history regressions ([cbba96c](https://github.com/IBM/kui/commit/cbba96c)), closes [#5283](https://github.com/IBM/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/IBM/kui/commit/56f69cb)), closes [#5024](https://github.com/IBM/kui/issues/5024)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- remove TreeResponse and PatternFly Tree Component ([e539a53](https://github.com/IBM/kui/commit/e539a53)), closes [#6581](https://github.com/IBM/kui/issues/6581) [#6328](https://github.com/IBM/kui/issues/6328)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/IBM/kui/commit/128ec92)), closes [#5495](https://github.com/IBM/kui/issues/5495)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/IBM/kui/commit/8d4cf8c)), closes [#5730](https://github.com/IBM/kui/issues/5730)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/IBM/kui/commit/51a2aad)), closes [#6014](https://github.com/IBM/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/IBM/kui/commit/8f9dc23)), closes [#5626](https://github.com/IBM/kui/issues/5626)
- tree should support leaf node drilling down ([006b881](https://github.com/IBM/kui/commit/006b881)), closes [#6293](https://github.com/IBM/kui/issues/6293)
- use Dropdown component for RadioTable impl ([244b16a](https://github.com/IBM/kui/commit/244b16a)), closes [#6539](https://github.com/IBM/kui/issues/6539)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/IBM/kui/commit/fbe367c)), closes [#5434](https://github.com/IBM/kui/issues/5434)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/IBM/kui/commit/49bfbcc)), closes [#4855](https://github.com/IBM/kui/issues/4855)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/IBM/kui/commit/d1aa46d)), closes [#5285](https://github.com/IBM/kui/issues/5285)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/IBM/kui/commit/4cc16be)), closes [#5176](https://github.com/IBM/kui/issues/5176)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/IBM/kui/commit/3c14da5)), closes [#4945](https://github.com/IBM/kui/issues/4945)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- **plugins/plugin-kubectl:** use PaginatedTable instead of RadioTable for `contexts` and `get namespaces` commands ([20f0737](https://github.com/IBM/kui/commit/20f0737)), closes [#6517](https://github.com/IBM/kui/issues/6517)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)

### Features

- add events to sidecar tree ([dd4d552](https://github.com/IBM/kui/commit/dd4d552)), closes [#6140](https://github.com/IBM/kui/issues/6140)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/IBM/kui/commit/e9028ee)), closes [#5336](https://github.com/IBM/kui/issues/5336)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/IBM/kui/commit/85ea2d5)), closes [#6132](https://github.com/IBM/kui/issues/6132)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/IBM/kui/commit/eb9f147)), closes [#5282](https://github.com/IBM/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/IBM/kui/commit/f4ba8e6)), closes [#5278](https://github.com/IBM/kui/issues/5278)
- background new tabs ([be9f986](https://github.com/IBM/kui/commit/be9f986)), closes [#5550](https://github.com/IBM/kui/issues/5550)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/IBM/kui/commit/3a199c7)), closes [#6348](https://github.com/IBM/kui/issues/6348)
- custom tab titles ([fd780df](https://github.com/IBM/kui/commit/fd780df)), closes [#5525](https://github.com/IBM/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/IBM/kui/commit/b0b95cf)), closes [#5879](https://github.com/IBM/kui/issues/5879)
- Expand kubectl direct watching to support heterogeneous use cases ([8df1ad3](https://github.com/IBM/kui/commit/8df1ad3)), closes [#6504](https://github.com/IBM/kui/issues/6504)
- generalized kuberctl get with limit ([d40ee07](https://github.com/IBM/kui/commit/d40ee07)), closes [#5361](https://github.com/IBM/kui/issues/5361)
- improve repl-block selection ([305b36f](https://github.com/IBM/kui/commit/305b36f)), closes [#5587](https://github.com/IBM/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/IBM/kui/commit/5744bf4)), closes [#5513](https://github.com/IBM/kui/issues/5513)
- initial support for using a kubectl proxy ([47b26be](https://github.com/IBM/kui/commit/47b26be)), closes [#6440](https://github.com/IBM/kui/issues/6440)
- inline sidecar ([2c3afeb](https://github.com/IBM/kui/commit/2c3afeb)), closes [#6007](https://github.com/IBM/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/IBM/kui/commit/fe80525)), closes [#6026](https://github.com/IBM/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/IBM/kui/commit/38d2895)), closes [#5537](https://github.com/IBM/kui/issues/5537)
- Meta-click on table entries should open the drilldown in a different split ([fb89c29](https://github.com/IBM/kui/commit/fb89c29)), closes [#6403](https://github.com/IBM/kui/issues/6403)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/IBM/kui/commit/b9c5867)), closes [#6109](https://github.com/IBM/kui/issues/6109)
- pass command line comments to commentary command ([a020db5](https://github.com/IBM/kui/commit/a020db5)), closes [#5459](https://github.com/IBM/kui/issues/5459)
- save/restore pty command output ([2c291a9](https://github.com/IBM/kui/commit/2c291a9)), closes [#5314](https://github.com/IBM/kui/issues/5314)
- show buttons of related resources in sidecar footer ([e10f7f2](https://github.com/IBM/kui/commit/e10f7f2)), closes [#6856](https://github.com/IBM/kui/issues/6856)
- use Accordion for SourceRef ([1b11736](https://github.com/IBM/kui/commit/1b11736)), closes [#6097](https://github.com/IBM/kui/issues/6097)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/IBM/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/IBM/kui/commit/0f7648c)), closes [#6351](https://github.com/IBM/kui/issues/6351)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/IBM/kui/commit/c5384e0)), closes [#4570](https://github.com/IBM/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/IBM/kui/commit/e935092)), closes [#5576](https://github.com/IBM/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/IBM/kui/commit/f7f6918)), closes [#5589](https://github.com/IBM/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/IBM/kui/commit/a72cf8d)), closes [#5752](https://github.com/IBM/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/IBM/kui/commit/6d828c1)), closes [#5664](https://github.com/IBM/kui/issues/5664)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/IBM/kui/commit/1f544b5)), closes [#5667](https://github.com/IBM/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/IBM/kui/commit/791160e)), closes [#5472](https://github.com/IBM/kui/issues/5472)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/IBM/kui/commit/1e2fb41)), closes [#5342](https://github.com/IBM/kui/issues/5342)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/IBM/kui/commit/75857e9)), closes [#5746](https://github.com/IBM/kui/issues/5746)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/IBM/kui/commit/59a9213)), closes [#5256](https://github.com/IBM/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/IBM/kui/commit/677faca)), closes [#5302](https://github.com/IBM/kui/issues/5302) [#5303](https://github.com/IBM/kui/issues/5303)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/IBM/kui/commit/f94a22f)), closes [#6136](https://github.com/IBM/kui/issues/6136)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/IBM/kui/commit/d8d13ab)), closes [#4973](https://github.com/IBM/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/IBM/kui/commit/495d3bb)), closes [#4957](https://github.com/IBM/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/IBM/kui/commit/0c33e6e)), closes [#4990](https://github.com/IBM/kui/issues/4990) [#5007](https://github.com/IBM/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/IBM/kui/commit/c6dc99f)), closes [#5173](https://github.com/IBM/kui/issues/5173)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- command history should be tab-specific ([1b987e0](https://github.com/IBM/kui/commit/1b987e0)), closes [#1299](https://github.com/IBM/kui/issues/1299)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/IBM/kui/commit/70b8441)), closes [#5112](https://github.com/IBM/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/IBM/kui/commit/662f413)), closes [#4865](https://github.com/IBM/kui/issues/4865) [#4573](https://github.com/IBM/kui/issues/4573) [#4885](https://github.com/IBM/kui/issues/4885) [#4894](https://github.com/IBM/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/IBM/kui/commit/51669af)), closes [#5115](https://github.com/IBM/kui/issues/5115)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/IBM/kui/commit/d4f6984)), closes [#4909](https://github.com/IBM/kui/issues/4909)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- support replaying in new tab ([04a2c67](https://github.com/IBM/kui/commit/04a2c67)), closes [#5509](https://github.com/IBM/kui/issues/5509)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [9.3.0](https://github.com/IBM/kui/compare/v4.5.0...v9.3.0) (2020-12-11)

### Bug Fixes

- tree should support leaf node drilling down ([006b881](https://github.com/IBM/kui/commit/006b881)), closes [#6293](https://github.com/IBM/kui/issues/6293)
- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/IBM/kui/commit/486a02e)), closes [#6134](https://github.com/IBM/kui/issues/6134)
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/IBM/kui/commit/f8486f8)), closes [#5629](https://github.com/IBM/kui/issues/5629)
- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/IBM/kui/commit/80192d5)), closes [#6001](https://github.com/IBM/kui/issues/6001)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/IBM/kui/commit/50ced8f)), closes [#4896](https://github.com/IBM/kui/issues/4896)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/IBM/kui/commit/470da34)), closes [#5604](https://github.com/IBM/kui/issues/5604)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- improved support for replaying splits ([8039a9d](https://github.com/IBM/kui/commit/8039a9d)), closes [#5535](https://github.com/IBM/kui/issues/5535)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- multiple command history regressions ([cbba96c](https://github.com/IBM/kui/commit/cbba96c)), closes [#5283](https://github.com/IBM/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/IBM/kui/commit/56f69cb)), closes [#5024](https://github.com/IBM/kui/issues/5024)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/IBM/kui/commit/128ec92)), closes [#5495](https://github.com/IBM/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/IBM/kui/commit/8d4cf8c)), closes [#5730](https://github.com/IBM/kui/issues/5730)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/IBM/kui/commit/51a2aad)), closes [#6014](https://github.com/IBM/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/IBM/kui/commit/8f9dc23)), closes [#5626](https://github.com/IBM/kui/issues/5626)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/IBM/kui/commit/fbe367c)), closes [#5434](https://github.com/IBM/kui/issues/5434)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/IBM/kui/commit/49bfbcc)), closes [#4855](https://github.com/IBM/kui/issues/4855)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/IBM/kui/commit/d1aa46d)), closes [#5285](https://github.com/IBM/kui/issues/5285)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/IBM/kui/commit/4cc16be)), closes [#5176](https://github.com/IBM/kui/issues/5176)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/IBM/kui/commit/3c14da5)), closes [#4945](https://github.com/IBM/kui/issues/4945)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)

### Features

- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/IBM/kui/commit/d8d13ab)), closes [#4973](https://github.com/IBM/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/IBM/kui/commit/495d3bb)), closes [#4957](https://github.com/IBM/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/IBM/kui/commit/0c33e6e)), closes [#4990](https://github.com/IBM/kui/issues/4990) [#5007](https://github.com/IBM/kui/issues/5007)
- add events to sidecar tree ([dd4d552](https://github.com/IBM/kui/commit/dd4d552)), closes [#6140](https://github.com/IBM/kui/issues/6140)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/IBM/kui/commit/e9028ee)), closes [#5336](https://github.com/IBM/kui/issues/5336)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/IBM/kui/commit/85ea2d5)), closes [#6132](https://github.com/IBM/kui/issues/6132)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/IBM/kui/commit/eb9f147)), closes [#5282](https://github.com/IBM/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/IBM/kui/commit/f4ba8e6)), closes [#5278](https://github.com/IBM/kui/issues/5278)
- background new tabs ([be9f986](https://github.com/IBM/kui/commit/be9f986)), closes [#5550](https://github.com/IBM/kui/issues/5550)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- clicking changed files in the `git status widget` should show `git diff` result in a DiffEditor ([3a199c7](https://github.com/IBM/kui/commit/3a199c7)), closes [#6348](https://github.com/IBM/kui/issues/6348)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/IBM/kui/commit/c6dc99f)), closes [#5173](https://github.com/IBM/kui/issues/5173)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- command history should be tab-specific ([1b987e0](https://github.com/IBM/kui/commit/1b987e0)), closes [#1299](https://github.com/IBM/kui/issues/1299)
- custom tab titles ([fd780df](https://github.com/IBM/kui/commit/fd780df)), closes [#5525](https://github.com/IBM/kui/issues/5525)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/IBM/kui/commit/b0b95cf)), closes [#5879](https://github.com/IBM/kui/issues/5879)
- generalized kuberctl get with limit ([d40ee07](https://github.com/IBM/kui/commit/d40ee07)), closes [#5361](https://github.com/IBM/kui/issues/5361)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- improve repl-block selection ([305b36f](https://github.com/IBM/kui/commit/305b36f)), closes [#5587](https://github.com/IBM/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/IBM/kui/commit/5744bf4)), closes [#5513](https://github.com/IBM/kui/issues/5513)
- inline sidecar ([2c3afeb](https://github.com/IBM/kui/commit/2c3afeb)), closes [#6007](https://github.com/IBM/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/IBM/kui/commit/fe80525)), closes [#6026](https://github.com/IBM/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/IBM/kui/commit/38d2895)), closes [#5537](https://github.com/IBM/kui/issues/5537)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/IBM/kui/commit/70b8441)), closes [#5112](https://github.com/IBM/kui/issues/5112)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/IBM/kui/commit/b9c5867)), closes [#6109](https://github.com/IBM/kui/issues/6109)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pass command line comments to commentary command ([a020db5](https://github.com/IBM/kui/commit/a020db5)), closes [#5459](https://github.com/IBM/kui/issues/5459)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/IBM/kui/commit/662f413)), closes [#4865](https://github.com/IBM/kui/issues/4865) [#4573](https://github.com/IBM/kui/issues/4573) [#4885](https://github.com/IBM/kui/issues/4885) [#4894](https://github.com/IBM/kui/issues/4894)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/IBM/kui/commit/51669af)), closes [#5115](https://github.com/IBM/kui/issues/5115)
- use Accordion for SourceRef ([1b11736](https://github.com/IBM/kui/commit/1b11736)), closes [#6097](https://github.com/IBM/kui/issues/6097)
- use Monaco DiffEditor `kubectl diff` ([3157393](https://github.com/IBM/kui/commit/3157393))
- use new Dropdown status stripe for CurrentNamespace widget ([0f7648c](https://github.com/IBM/kui/commit/0f7648c)), closes [#6351](https://github.com/IBM/kui/issues/6351)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/IBM/kui/commit/c5384e0)), closes [#4570](https://github.com/IBM/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/IBM/kui/commit/e935092)), closes [#5576](https://github.com/IBM/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/IBM/kui/commit/f7f6918)), closes [#5589](https://github.com/IBM/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/IBM/kui/commit/a72cf8d)), closes [#5752](https://github.com/IBM/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/IBM/kui/commit/6d828c1)), closes [#5664](https://github.com/IBM/kui/issues/5664)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/IBM/kui/commit/1f544b5)), closes [#5667](https://github.com/IBM/kui/issues/5667)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/IBM/kui/commit/791160e)), closes [#5472](https://github.com/IBM/kui/issues/5472)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/IBM/kui/commit/1e2fb41)), closes [#5342](https://github.com/IBM/kui/issues/5342)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/IBM/kui/commit/75857e9)), closes [#5746](https://github.com/IBM/kui/issues/5746)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/IBM/kui/commit/59a9213)), closes [#5256](https://github.com/IBM/kui/issues/5256)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/IBM/kui/commit/f94a22f)), closes [#6136](https://github.com/IBM/kui/issues/6136)
- save/restore pty command output ([2c291a9](https://github.com/IBM/kui/commit/2c291a9)), closes [#5314](https://github.com/IBM/kui/issues/5314)
- support replaying in new tab ([04a2c67](https://github.com/IBM/kui/commit/04a2c67)), closes [#5509](https://github.com/IBM/kui/issues/5509)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/IBM/kui/commit/d4f6984)), closes [#4909](https://github.com/IBM/kui/issues/4909)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/IBM/kui/commit/677faca)), closes [#5302](https://github.com/IBM/kui/issues/5302) [#5303](https://github.com/IBM/kui/issues/5303)

# [9.2.0](https://github.com/IBM/kui/compare/v4.5.0...v9.2.0) (2020-11-25)

### Bug Fixes

- **plugins/plugin-client-common:** externalize PatternFly TreeView component to SPI ([486a02e](https://github.com/IBM/kui/commit/486a02e)), closes [#6134](https://github.com/IBM/kui/issues/6134)
- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/IBM/kui/commit/f8486f8)), closes [#5629](https://github.com/IBM/kui/issues/5629)
- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/IBM/kui/commit/80192d5)), closes [#6001](https://github.com/IBM/kui/issues/6001)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/IBM/kui/commit/50ced8f)), closes [#4896](https://github.com/IBM/kui/issues/4896)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/IBM/kui/commit/470da34)), closes [#5604](https://github.com/IBM/kui/issues/5604)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- improved support for replaying splits ([8039a9d](https://github.com/IBM/kui/commit/8039a9d)), closes [#5535](https://github.com/IBM/kui/issues/5535)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- multiple command history regressions ([cbba96c](https://github.com/IBM/kui/commit/cbba96c)), closes [#5283](https://github.com/IBM/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/IBM/kui/commit/56f69cb)), closes [#5024](https://github.com/IBM/kui/issues/5024)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/IBM/kui/commit/128ec92)), closes [#5495](https://github.com/IBM/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/IBM/kui/commit/8d4cf8c)), closes [#5730](https://github.com/IBM/kui/issues/5730)
- Switching Carbon tabs can cause content to scroll off-viewport ([51a2aad](https://github.com/IBM/kui/commit/51a2aad)), closes [#6014](https://github.com/IBM/kui/issues/6014)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/IBM/kui/commit/8f9dc23)), closes [#5626](https://github.com/IBM/kui/issues/5626)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/IBM/kui/commit/fbe367c)), closes [#5434](https://github.com/IBM/kui/issues/5434)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/IBM/kui/commit/49bfbcc)), closes [#4855](https://github.com/IBM/kui/issues/4855)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/IBM/kui/commit/d1aa46d)), closes [#5285](https://github.com/IBM/kui/issues/5285)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/IBM/kui/commit/4cc16be)), closes [#5176](https://github.com/IBM/kui/issues/5176)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/IBM/kui/commit/3c14da5)), closes [#4945](https://github.com/IBM/kui/issues/4945)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)

### Features

- add events to sidecar tree ([dd4d552](https://github.com/IBM/kui/commit/dd4d552)), closes [#6140](https://github.com/IBM/kui/issues/6140)
- **plugins/plugin-kubectl:** kubectl get -f can use Tree to present structured result ([f94a22f](https://github.com/IBM/kui/commit/f94a22f)), closes [#6136](https://github.com/IBM/kui/issues/6136)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/IBM/kui/commit/e9028ee)), closes [#5336](https://github.com/IBM/kui/issues/5336)
- add unit support of TreeResponse as one of the contents in MultiModalResponse ([85ea2d5](https://github.com/IBM/kui/commit/85ea2d5)), closes [#6132](https://github.com/IBM/kui/issues/6132)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/IBM/kui/commit/eb9f147)), closes [#5282](https://github.com/IBM/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/IBM/kui/commit/f4ba8e6)), closes [#5278](https://github.com/IBM/kui/issues/5278)
- background new tabs ([be9f986](https://github.com/IBM/kui/commit/be9f986)), closes [#5550](https://github.com/IBM/kui/issues/5550)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/IBM/kui/commit/c6dc99f)), closes [#5173](https://github.com/IBM/kui/issues/5173)
- command history should be tab-specific ([1b987e0](https://github.com/IBM/kui/commit/1b987e0)), closes [#1299](https://github.com/IBM/kui/issues/1299)
- custom tab titles ([fd780df](https://github.com/IBM/kui/commit/fd780df)), closes [#5525](https://github.com/IBM/kui/issues/5525)
- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/IBM/kui/commit/b0b95cf)), closes [#5879](https://github.com/IBM/kui/issues/5879)
- generalized kuberctl get with limit ([d40ee07](https://github.com/IBM/kui/commit/d40ee07)), closes [#5361](https://github.com/IBM/kui/issues/5361)
- improve repl-block selection ([305b36f](https://github.com/IBM/kui/commit/305b36f)), closes [#5587](https://github.com/IBM/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/IBM/kui/commit/5744bf4)), closes [#5513](https://github.com/IBM/kui/issues/5513)
- inline sidecar ([2c3afeb](https://github.com/IBM/kui/commit/2c3afeb)), closes [#6007](https://github.com/IBM/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/IBM/kui/commit/fe80525)), closes [#6026](https://github.com/IBM/kui/issues/6026)
- inverse splits ([38d2895](https://github.com/IBM/kui/commit/38d2895)), closes [#5537](https://github.com/IBM/kui/issues/5537)
- Move in OpenWhisk plugin from the external repo ([b9c5867](https://github.com/IBM/kui/commit/b9c5867)), closes [#6109](https://github.com/IBM/kui/issues/6109)
- use Accordion for SourceRef ([1b11736](https://github.com/IBM/kui/commit/1b11736)), closes [#6097](https://github.com/IBM/kui/issues/6097)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/IBM/kui/commit/c5384e0)), closes [#4570](https://github.com/IBM/kui/issues/4570)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/IBM/kui/commit/e935092)), closes [#5576](https://github.com/IBM/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/IBM/kui/commit/f7f6918)), closes [#5589](https://github.com/IBM/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/IBM/kui/commit/a72cf8d)), closes [#5752](https://github.com/IBM/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/IBM/kui/commit/6d828c1)), closes [#5664](https://github.com/IBM/kui/issues/5664)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/IBM/kui/commit/1e2fb41)), closes [#5342](https://github.com/IBM/kui/issues/5342)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/IBM/kui/commit/75857e9)), closes [#5746](https://github.com/IBM/kui/issues/5746)
- save/restore pty command output ([2c291a9](https://github.com/IBM/kui/commit/2c291a9)), closes [#5314](https://github.com/IBM/kui/issues/5314)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/IBM/kui/commit/1f544b5)), closes [#5667](https://github.com/IBM/kui/issues/5667)
- support replaying in new tab ([04a2c67](https://github.com/IBM/kui/commit/04a2c67)), closes [#5509](https://github.com/IBM/kui/issues/5509)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/IBM/kui/commit/791160e)), closes [#5472](https://github.com/IBM/kui/issues/5472)
- pass command line comments to commentary command ([a020db5](https://github.com/IBM/kui/commit/a020db5)), closes [#5459](https://github.com/IBM/kui/issues/5459)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/IBM/kui/commit/59a9213)), closes [#5256](https://github.com/IBM/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/IBM/kui/commit/677faca)), closes [#5302](https://github.com/IBM/kui/issues/5302) [#5303](https://github.com/IBM/kui/issues/5303)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/IBM/kui/commit/d8d13ab)), closes [#4973](https://github.com/IBM/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/IBM/kui/commit/495d3bb)), closes [#4957](https://github.com/IBM/kui/issues/4957)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/IBM/kui/commit/0c33e6e)), closes [#4990](https://github.com/IBM/kui/issues/4990) [#5007](https://github.com/IBM/kui/issues/5007)
- MiniSplits ([70b8441](https://github.com/IBM/kui/commit/70b8441)), closes [#5112](https://github.com/IBM/kui/issues/5112)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/IBM/kui/commit/d4f6984)), closes [#4909](https://github.com/IBM/kui/issues/4909)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/IBM/kui/commit/662f413)), closes [#4865](https://github.com/IBM/kui/issues/4865) [#4573](https://github.com/IBM/kui/issues/4573) [#4885](https://github.com/IBM/kui/issues/4885) [#4894](https://github.com/IBM/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/IBM/kui/commit/51669af)), closes [#5115](https://github.com/IBM/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [9.1.0](https://github.com/IBM/kui/compare/v4.5.0...v9.1.0) (2020-10-26)

### Bug Fixes

- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/IBM/kui/commit/f8486f8)), closes [#5629](https://github.com/IBM/kui/issues/5629)
- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- don't show "Created a split" when clicking on the New Split button ([80192d5](https://github.com/IBM/kui/commit/80192d5)), closes [#6001](https://github.com/IBM/kui/issues/6001)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/IBM/kui/commit/50ced8f)), closes [#4896](https://github.com/IBM/kui/issues/4896)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/IBM/kui/commit/470da34)), closes [#5604](https://github.com/IBM/kui/issues/5604)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- improved support for replaying splits ([8039a9d](https://github.com/IBM/kui/commit/8039a9d)), closes [#5535](https://github.com/IBM/kui/issues/5535)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- multiple command history regressions ([cbba96c](https://github.com/IBM/kui/commit/cbba96c)), closes [#5283](https://github.com/IBM/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/IBM/kui/commit/56f69cb)), closes [#5024](https://github.com/IBM/kui/issues/5024)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/IBM/kui/commit/128ec92)), closes [#5495](https://github.com/IBM/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/IBM/kui/commit/8d4cf8c)), closes [#5730](https://github.com/IBM/kui/issues/5730)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/IBM/kui/commit/8f9dc23)), closes [#5626](https://github.com/IBM/kui/issues/5626)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/IBM/kui/commit/fbe367c)), closes [#5434](https://github.com/IBM/kui/issues/5434)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/IBM/kui/commit/49bfbcc)), closes [#4855](https://github.com/IBM/kui/issues/4855)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/IBM/kui/commit/d1aa46d)), closes [#5285](https://github.com/IBM/kui/issues/5285)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/IBM/kui/commit/4cc16be)), closes [#5176](https://github.com/IBM/kui/issues/5176)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/IBM/kui/commit/3c14da5)), closes [#4945](https://github.com/IBM/kui/issues/4945)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)

### Features

- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/IBM/kui/commit/b0b95cf)), closes [#5879](https://github.com/IBM/kui/issues/5879)
- inline sidecar ([2c3afeb](https://github.com/IBM/kui/commit/2c3afeb)), closes [#6007](https://github.com/IBM/kui/issues/6007)
- introduce reexec for rerunning commands ([fe80525](https://github.com/IBM/kui/commit/fe80525)), closes [#6026](https://github.com/IBM/kui/issues/6026)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/IBM/kui/commit/e935092)), closes [#5576](https://github.com/IBM/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/IBM/kui/commit/f7f6918)), closes [#5589](https://github.com/IBM/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/IBM/kui/commit/a72cf8d)), closes [#5752](https://github.com/IBM/kui/issues/5752)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/IBM/kui/commit/75857e9)), closes [#5746](https://github.com/IBM/kui/issues/5746)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/IBM/kui/commit/d8d13ab)), closes [#4973](https://github.com/IBM/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/IBM/kui/commit/495d3bb)), closes [#4957](https://github.com/IBM/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/IBM/kui/commit/0c33e6e)), closes [#4990](https://github.com/IBM/kui/issues/4990) [#5007](https://github.com/IBM/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/IBM/kui/commit/e9028ee)), closes [#5336](https://github.com/IBM/kui/issues/5336)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/IBM/kui/commit/5744bf4)), closes [#5513](https://github.com/IBM/kui/issues/5513)
- save/restore pty command output ([2c291a9](https://github.com/IBM/kui/commit/2c291a9)), closes [#5314](https://github.com/IBM/kui/issues/5314)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/IBM/kui/commit/6d828c1)), closes [#5664](https://github.com/IBM/kui/issues/5664)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/IBM/kui/commit/1f544b5)), closes [#5667](https://github.com/IBM/kui/issues/5667)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/IBM/kui/commit/eb9f147)), closes [#5282](https://github.com/IBM/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/IBM/kui/commit/f4ba8e6)), closes [#5278](https://github.com/IBM/kui/issues/5278)
- background new tabs ([be9f986](https://github.com/IBM/kui/commit/be9f986)), closes [#5550](https://github.com/IBM/kui/issues/5550)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- custom tab titles ([fd780df](https://github.com/IBM/kui/commit/fd780df)), closes [#5525](https://github.com/IBM/kui/issues/5525)
- generalized kuberctl get with limit ([d40ee07](https://github.com/IBM/kui/commit/d40ee07)), closes [#5361](https://github.com/IBM/kui/issues/5361)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- improve repl-block selection ([305b36f](https://github.com/IBM/kui/commit/305b36f)), closes [#5587](https://github.com/IBM/kui/issues/5587)
- inverse splits ([38d2895](https://github.com/IBM/kui/commit/38d2895)), closes [#5537](https://github.com/IBM/kui/issues/5537)
- support replaying in new tab ([04a2c67](https://github.com/IBM/kui/commit/04a2c67)), closes [#5509](https://github.com/IBM/kui/issues/5509)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/IBM/kui/commit/c5384e0)), closes [#4570](https://github.com/IBM/kui/issues/4570)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/IBM/kui/commit/791160e)), closes [#5472](https://github.com/IBM/kui/issues/5472)
- MiniSplits ([70b8441](https://github.com/IBM/kui/commit/70b8441)), closes [#5112](https://github.com/IBM/kui/issues/5112)
- pass command line comments to commentary command ([a020db5](https://github.com/IBM/kui/commit/a020db5)), closes [#5459](https://github.com/IBM/kui/issues/5459)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/IBM/kui/commit/1e2fb41)), closes [#5342](https://github.com/IBM/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/IBM/kui/commit/d4f6984)), closes [#4909](https://github.com/IBM/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/IBM/kui/commit/59a9213)), closes [#5256](https://github.com/IBM/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/IBM/kui/commit/677faca)), closes [#5302](https://github.com/IBM/kui/issues/5302) [#5303](https://github.com/IBM/kui/issues/5303)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/IBM/kui/commit/c6dc99f)), closes [#5173](https://github.com/IBM/kui/issues/5173)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- command history should be tab-specific ([1b987e0](https://github.com/IBM/kui/commit/1b987e0)), closes [#1299](https://github.com/IBM/kui/issues/1299)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/IBM/kui/commit/662f413)), closes [#4865](https://github.com/IBM/kui/issues/4865) [#4573](https://github.com/IBM/kui/issues/4573) [#4885](https://github.com/IBM/kui/issues/4885) [#4894](https://github.com/IBM/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/IBM/kui/commit/51669af)), closes [#5115](https://github.com/IBM/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [9.0.0](https://github.com/IBM/kui/compare/v4.5.0...v9.0.0) (2020-10-08)

### Bug Fixes

- "created split" message should disappear when corresponding split is closed ([f8486f8](https://github.com/IBM/kui/commit/f8486f8)), closes [#5629](https://github.com/IBM/kui/issues/5629)
- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/IBM/kui/commit/50ced8f)), closes [#4896](https://github.com/IBM/kui/issues/4896)
- improve the discoverability of repl-block action buttons ([470da34](https://github.com/IBM/kui/commit/470da34)), closes [#5604](https://github.com/IBM/kui/issues/5604)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- improved support for replaying splits ([8039a9d](https://github.com/IBM/kui/commit/8039a9d)), closes [#5535](https://github.com/IBM/kui/issues/5535)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- multiple command history regressions ([cbba96c](https://github.com/IBM/kui/commit/cbba96c)), closes [#5283](https://github.com/IBM/kui/issues/5283)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/IBM/kui/commit/56f69cb)), closes [#5024](https://github.com/IBM/kui/issues/5024)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- restore status stripe to default behavior on terminal clear ([128ec92](https://github.com/IBM/kui/commit/128ec92)), closes [#5495](https://github.com/IBM/kui/issues/5495)
- sidecar shouldn't be opened automatically when replay ([8d4cf8c](https://github.com/IBM/kui/commit/8d4cf8c)), closes [#5730](https://github.com/IBM/kui/issues/5730)
- terminal clearing versus splits results in non-replayable splits ([8f9dc23](https://github.com/IBM/kui/commit/8f9dc23)), closes [#5626](https://github.com/IBM/kui/issues/5626)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-client-common:** add support for titles in commentary ([fbe367c](https://github.com/IBM/kui/commit/fbe367c)), closes [#5434](https://github.com/IBM/kui/issues/5434)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/IBM/kui/commit/49bfbcc)), closes [#4855](https://github.com/IBM/kui/issues/4855)
- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/IBM/kui/commit/d1aa46d)), closes [#5285](https://github.com/IBM/kui/issues/5285)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/IBM/kui/commit/4cc16be)), closes [#5176](https://github.com/IBM/kui/issues/5176)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/IBM/kui/commit/3c14da5)), closes [#4945](https://github.com/IBM/kui/issues/4945)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)

### Features

- execute the command in url query when the browser app is loaded ([b0b95cf](https://github.com/IBM/kui/commit/b0b95cf)), closes [#5879](https://github.com/IBM/kui/issues/5879)
- **plugins/plugin-client-common:** allow users to insert command before a repl block ([e935092](https://github.com/IBM/kui/commit/e935092)), closes [#5576](https://github.com/IBM/kui/issues/5576)
- **plugins/plugin-client-common:** allow users to reorder blocks by MoveUp and MoveDown buttons ([f7f6918](https://github.com/IBM/kui/commit/f7f6918)), closes [#5589](https://github.com/IBM/kui/issues/5589)
- **plugins/plugin-client-common:** block-level copy/paste ([a72cf8d](https://github.com/IBM/kui/commit/a72cf8d)), closes [#5752](https://github.com/IBM/kui/issues/5752)
- **plugins/plugin-client-common:** edit a commentary response using SimpleEditor ([6d828c1](https://github.com/IBM/kui/commit/6d828c1)), closes [#5664](https://github.com/IBM/kui/issues/5664)
- **plugins/plugin-client-common:** split command should allow user to specify splice index ([75857e9](https://github.com/IBM/kui/commit/75857e9)), closes [#5746](https://github.com/IBM/kui/issues/5746)
- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/IBM/kui/commit/d8d13ab)), closes [#4973](https://github.com/IBM/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/IBM/kui/commit/495d3bb)), closes [#4957](https://github.com/IBM/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/IBM/kui/commit/0c33e6e)), closes [#4990](https://github.com/IBM/kui/issues/4990) [#5007](https://github.com/IBM/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/IBM/kui/commit/e9028ee)), closes [#5336](https://github.com/IBM/kui/issues/5336)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/IBM/kui/commit/eb9f147)), closes [#5282](https://github.com/IBM/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/IBM/kui/commit/f4ba8e6)), closes [#5278](https://github.com/IBM/kui/issues/5278)
- background new tabs ([be9f986](https://github.com/IBM/kui/commit/be9f986)), closes [#5550](https://github.com/IBM/kui/issues/5550)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/IBM/kui/commit/c6dc99f)), closes [#5173](https://github.com/IBM/kui/issues/5173)
- command history should be tab-specific ([1b987e0](https://github.com/IBM/kui/commit/1b987e0)), closes [#1299](https://github.com/IBM/kui/issues/1299)
- custom tab titles ([fd780df](https://github.com/IBM/kui/commit/fd780df)), closes [#5525](https://github.com/IBM/kui/issues/5525)
- generalized kuberctl get with limit ([d40ee07](https://github.com/IBM/kui/commit/d40ee07)), closes [#5361](https://github.com/IBM/kui/issues/5361)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- improve repl-block selection ([305b36f](https://github.com/IBM/kui/commit/305b36f)), closes [#5587](https://github.com/IBM/kui/issues/5587)
- initial support for capturing input files and showing them in the UI ([5744bf4](https://github.com/IBM/kui/commit/5744bf4)), closes [#5513](https://github.com/IBM/kui/issues/5513)
- inverse splits ([38d2895](https://github.com/IBM/kui/commit/38d2895)), closes [#5537](https://github.com/IBM/kui/issues/5537)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- save/restore pty command output ([2c291a9](https://github.com/IBM/kui/commit/2c291a9)), closes [#5314](https://github.com/IBM/kui/issues/5314)
- **plugins/plugin-client-common:** Improve Commentary editing UI by adding real Done button ([1f544b5](https://github.com/IBM/kui/commit/1f544b5)), closes [#5667](https://github.com/IBM/kui/issues/5667)
- support replaying in new tab ([04a2c67](https://github.com/IBM/kui/commit/04a2c67)), closes [#5509](https://github.com/IBM/kui/issues/5509)
- **plugins/plugin-client-common:** allow easier rerunning of command from terminal ([c5384e0](https://github.com/IBM/kui/commit/c5384e0)), closes [#4570](https://github.com/IBM/kui/issues/4570)
- **plugins/plugin-client-common:** Improve notebook-style ui ([791160e](https://github.com/IBM/kui/commit/791160e)), closes [#5472](https://github.com/IBM/kui/issues/5472)
- pass command line comments to commentary command ([a020db5](https://github.com/IBM/kui/commit/a020db5)), closes [#5459](https://github.com/IBM/kui/issues/5459)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/IBM/kui/commit/1e2fb41)), closes [#5342](https://github.com/IBM/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/IBM/kui/commit/d4f6984)), closes [#4909](https://github.com/IBM/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/IBM/kui/commit/59a9213)), closes [#5256](https://github.com/IBM/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/IBM/kui/commit/677faca)), closes [#5302](https://github.com/IBM/kui/issues/5302) [#5303](https://github.com/IBM/kui/issues/5303)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/IBM/kui/commit/70b8441)), closes [#5112](https://github.com/IBM/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/IBM/kui/commit/662f413)), closes [#4865](https://github.com/IBM/kui/issues/4865) [#4573](https://github.com/IBM/kui/issues/4573) [#4885](https://github.com/IBM/kui/issues/4885) [#4894](https://github.com/IBM/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/IBM/kui/commit/51669af)), closes [#5115](https://github.com/IBM/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.12.0](https://github.com/IBM/kui/compare/v4.5.0...v8.12.0) (2020-08-20)

### Bug Fixes

- **plugins/plugin-client-common:** Grid regression: grid colors not right ([d1aa46d](https://github.com/IBM/kui/commit/d1aa46d)), closes [#5285](https://github.com/IBM/kui/issues/5285)
- multiple command history regressions ([cbba96c](https://github.com/IBM/kui/commit/cbba96c)), closes [#5283](https://github.com/IBM/kui/issues/5283)
- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/IBM/kui/commit/4cc16be)), closes [#5176](https://github.com/IBM/kui/issues/5176)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/IBM/kui/commit/56f69cb)), closes [#5024](https://github.com/IBM/kui/issues/5024)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/IBM/kui/commit/3c14da5)), closes [#4945](https://github.com/IBM/kui/issues/4945)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/IBM/kui/commit/50ced8f)), closes [#4896](https://github.com/IBM/kui/issues/4896)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/IBM/kui/commit/49bfbcc)), closes [#4855](https://github.com/IBM/kui/issues/4855)
- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)

### Features

- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/IBM/kui/commit/d8d13ab)), closes [#4973](https://github.com/IBM/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/IBM/kui/commit/495d3bb)), closes [#4957](https://github.com/IBM/kui/issues/4957)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/IBM/kui/commit/0c33e6e)), closes [#4990](https://github.com/IBM/kui/issues/4990) [#5007](https://github.com/IBM/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add sequence diagram to table with timestamp columns ([e9028ee](https://github.com/IBM/kui/commit/e9028ee)), closes [#5336](https://github.com/IBM/kui/issues/5336)
- allow command registrations to express their experimental nature ([eb9f147](https://github.com/IBM/kui/commit/eb9f147)), closes [#5282](https://github.com/IBM/kui/issues/5282)
- allow table model to specify a gridable column index ([f4ba8e6](https://github.com/IBM/kui/commit/f4ba8e6)), closes [#5278](https://github.com/IBM/kui/issues/5278)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/IBM/kui/commit/c6dc99f)), closes [#5173](https://github.com/IBM/kui/issues/5173)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- command history should be tab-specific ([1b987e0](https://github.com/IBM/kui/commit/1b987e0)), closes [#1299](https://github.com/IBM/kui/issues/1299)
- generalized kuberctl get with limit ([d40ee07](https://github.com/IBM/kui/commit/d40ee07)), closes [#5361](https://github.com/IBM/kui/issues/5361)
- **plugins/plugin-client-common:** improved SequenceDiagram view ([1e2fb41](https://github.com/IBM/kui/commit/1e2fb41)), closes [#5342](https://github.com/IBM/kui/issues/5342)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/IBM/kui/commit/d4f6984)), closes [#4909](https://github.com/IBM/kui/issues/4909)
- **plugins/plugin-git:** git branch should respond with RadioTable ([59a9213](https://github.com/IBM/kui/commit/59a9213)), closes [#5256](https://github.com/IBM/kui/issues/5256)
- **plugins/plugin-ibmcloud:** initial CodeEngine support ([677faca](https://github.com/IBM/kui/commit/677faca)), closes [#5302](https://github.com/IBM/kui/issues/5302) [#5303](https://github.com/IBM/kui/issues/5303)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/IBM/kui/commit/70b8441)), closes [#5112](https://github.com/IBM/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/IBM/kui/commit/662f413)), closes [#4865](https://github.com/IBM/kui/issues/4865) [#4573](https://github.com/IBM/kui/issues/4573) [#4885](https://github.com/IBM/kui/issues/4885) [#4894](https://github.com/IBM/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/IBM/kui/commit/51669af)), closes [#5115](https://github.com/IBM/kui/issues/5115)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.11.0](https://github.com/IBM/kui/compare/v4.5.0...v8.11.0) (2020-07-21)

### Bug Fixes

- **plugins/plugin-client-common:** improve display of empty watch tables ([4cc16be](https://github.com/IBM/kui/commit/4cc16be)), closes [#5176](https://github.com/IBM/kui/issues/5176)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- reduce custom CSS rules for table UI ([56f69cb](https://github.com/IBM/kui/commit/56f69cb)), closes [#5024](https://github.com/IBM/kui/issues/5024)
- **plugins/plugin-client-common:** make Close a top-level button in watch panes ([3c14da5](https://github.com/IBM/kui/commit/3c14da5)), closes [#4945](https://github.com/IBM/kui/issues/4945)
- improve hover effect for status stripe buttons ([50ced8f](https://github.com/IBM/kui/commit/50ced8f)), closes [#4896](https://github.com/IBM/kui/issues/4896)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/IBM/kui/commit/49bfbcc)), closes [#4855](https://github.com/IBM/kui/issues/4855)
- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)

### Features

- add a command to return the Card Component in Terminal ([d8d13ab](https://github.com/IBM/kui/commit/d8d13ab)), closes [#4973](https://github.com/IBM/kui/issues/4973)
- add alert command to display Alert component in Terminal ([495d3bb](https://github.com/IBM/kui/commit/495d3bb)), closes [#4957](https://github.com/IBM/kui/issues/4957)
- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add capability to show welcome widget to new users in Terminal ([0c33e6e](https://github.com/IBM/kui/commit/0c33e6e)), closes [#4990](https://github.com/IBM/kui/issues/4990) [#5007](https://github.com/IBM/kui/issues/5007)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- clicking on events in watch table should drill down to events ([c6dc99f](https://github.com/IBM/kui/commit/c6dc99f)), closes [#5173](https://github.com/IBM/kui/issues/5173)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- MiniSplits ([70b8441](https://github.com/IBM/kui/commit/70b8441)), closes [#5112](https://github.com/IBM/kui/issues/5112)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/IBM/kui/commit/662f413)), closes [#4865](https://github.com/IBM/kui/issues/4865) [#4573](https://github.com/IBM/kui/issues/4573) [#4885](https://github.com/IBM/kui/issues/4885) [#4894](https://github.com/IBM/kui/issues/4894)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support for events in table footer ([51669af](https://github.com/IBM/kui/commit/51669af)), closes [#5115](https://github.com/IBM/kui/issues/5115)
- **plugins/plugin-client-common:** support client option for hero names in sidecar ([d4f6984](https://github.com/IBM/kui/commit/d4f6984)), closes [#4909](https://github.com/IBM/kui/issues/4909)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.10.0](https://github.com/IBM/kui/compare/v4.5.0...v8.10.0) (2020-06-17)

### Bug Fixes

- improve hover effect for status stripe buttons ([50ced8f](https://github.com/IBM/kui/commit/50ced8f)), closes [#4896](https://github.com/IBM/kui/issues/4896)
- **plugins/plugin-client-common:** clicking the remove button of a repl block results in an error white screen ([49bfbcc](https://github.com/IBM/kui/commit/49bfbcc)), closes [#4855](https://github.com/IBM/kui/issues/4855)
- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)

### Features

- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pin a watchable terminal response in a split pane ([662f413](https://github.com/IBM/kui/commit/662f413)), closes [#4865](https://github.com/IBM/kui/issues/4865) [#4573](https://github.com/IBM/kui/issues/4573) [#4885](https://github.com/IBM/kui/issues/4885) [#4894](https://github.com/IBM/kui/issues/4894)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.9.0](https://github.com/IBM/kui/compare/v4.5.0...v8.9.0) (2020-06-09)

### Bug Fixes

- about should show breadcrumbs ([99dc401](https://github.com/IBM/kui/commit/99dc401)), closes [#4730](https://github.com/IBM/kui/issues/4730)
- allow user to disable table title by feature flags, and disable table pagination ([5450512](https://github.com/IBM/kui/commit/5450512)), closes [#4640](https://github.com/IBM/kui/issues/4640) [#4655](https://github.com/IBM/kui/issues/4655)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- avoid recomputing tabs when switching back and forth ([cf5e41f](https://github.com/IBM/kui/commit/cf5e41f)), closes [#4666](https://github.com/IBM/kui/issues/4666)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- improve alignment of icons ([221d0f9](https://github.com/IBM/kui/commit/221d0f9)), closes [#4555](https://github.com/IBM/kui/issues/4555)
- improve error reporting for kubectl apply ([fe21671](https://github.com/IBM/kui/commit/fe21671)), closes [#4605](https://github.com/IBM/kui/issues/4605)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Input element throws react error ([e6bb21b](https://github.com/IBM/kui/commit/e6bb21b)), closes [#4765](https://github.com/IBM/kui/issues/4765)
- kubectl edit apply twice does not work ([1976134](https://github.com/IBM/kui/commit/1976134)), closes [#4797](https://github.com/IBM/kui/issues/4797)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- sidecar toolbar can't due justice to longer error messages ([e67e0c9](https://github.com/IBM/kui/commit/e67e0c9)), closes [#4789](https://github.com/IBM/kui/issues/4789)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- **plugins/plugin-client-common:** stop using Carbon's TooltipIcon for DropDown ([be04d20](https://github.com/IBM/kui/commit/be04d20)), closes [#4767](https://github.com/IBM/kui/issues/4767)
- kubectl api-resources has duplicate rows and odd pagination behavior ([e740270](https://github.com/IBM/kui/commit/e740270)), closes [#4626](https://github.com/IBM/kui/issues/4626)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- sidecar back/forward should be ordered by visitation rather than insertion ([fba613a](https://github.com/IBM/kui/commit/fba613a)), closes [#4746](https://github.com/IBM/kui/issues/4746)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)

### Features

- add button to WatchPane to show table back in terminal ([dc22591](https://github.com/IBM/kui/commit/dc22591)), closes [#4530](https://github.com/IBM/kui/issues/4530)
- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- add Stop Watching capability to WatchPane ([09043c1](https://github.com/IBM/kui/commit/09043c1)), closes [#4554](https://github.com/IBM/kui/issues/4554)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- port kubectl get ns to RadioTable ([be0eabf](https://github.com/IBM/kui/commit/be0eabf)), closes [#4510](https://github.com/IBM/kui/issues/4510) [#4511](https://github.com/IBM/kui/issues/4511)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- split screen Terminal ([3a6b422](https://github.com/IBM/kui/commit/3a6b422)), closes [#4814](https://github.com/IBM/kui/issues/4814) [#4821](https://github.com/IBM/kui/issues/4821)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- target kubectl logs and kubectl exec to Logs and Terminal tabs ([409e632](https://github.com/IBM/kui/commit/409e632)), closes [#4762](https://github.com/IBM/kui/issues/4762)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- watcher panel for open-ended watch jobs ([6dfe7df](https://github.com/IBM/kui/commit/6dfe7df)), closes [#4503](https://github.com/IBM/kui/issues/4503)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.7.0](https://github.com/IBM/kui/compare/v4.5.0...v8.7.0) (2020-05-08)

### Bug Fixes

- hitting escape on initial page load toggles open empty sidecar ([8fbdce5](https://github.com/IBM/kui/commit/8fbdce5)), closes [#4487](https://github.com/IBM/kui/issues/4487)
- **plugin-kubectl:** k get pods --all-namespaces has a title with "default" as the namespace ([2f95129](https://github.com/IBM/kui/commit/2f95129)), closes [#4466](https://github.com/IBM/kui/issues/4466)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)

### Features

- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl edit via kui's editor ([414e813](https://github.com/IBM/kui/commit/414e813)), closes [#762](https://github.com/IBM/kui/issues/762)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- top tab buttons ([ff8cfba](https://github.com/IBM/kui/commit/ff8cfba)), closes [#4434](https://github.com/IBM/kui/issues/4434)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

## [8.6.1](https://github.com/IBM/kui/compare/v4.5.0...v8.6.1) (2020-04-25)

### Bug Fixes

- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)

### Features

- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.6.0](https://github.com/IBM/kui/compare/v4.5.0...v8.6.0) (2020-04-23)

### Bug Fixes

- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)

### Features

- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.5.0](https://github.com/IBM/kui/compare/v4.5.0...v8.5.0) (2020-04-19)

### Bug Fixes

- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- remove config.d/version.json in favor of using the version field from package.json ([1e296c7](https://github.com/IBM/kui/commit/1e296c7)), closes [#4300](https://github.com/IBM/kui/issues/4300)
- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)

### Features

- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

## [8.4.2](https://github.com/IBM/kui/compare/v4.5.0...v8.4.2) (2020-04-10)

### Bug Fixes

- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)

### Features

- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

## [8.4.1](https://github.com/IBM/kui/compare/v4.5.0...v8.4.1) (2020-04-10)

### Bug Fixes

- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)

### Features

- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.4.0](https://github.com/IBM/kui/compare/v4.5.0...v8.4.0) (2020-04-10)

### Bug Fixes

- sidecar Toolbar component renders empty if there is no Toolbar content ([14c27ba](https://github.com/IBM/kui/commit/14c27ba)), closes [#4229](https://github.com/IBM/kui/issues/4229)
- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)

### Features

- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.1.0](https://github.com/IBM/kui/compare/v4.5.0...v8.1.0) (2020-04-04)

### Bug Fixes

- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)

### Features

- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- add labels to summary mode ([95f731d](https://github.com/IBM/kui/commit/95f731d)), closes [#4041](https://github.com/IBM/kui/issues/4041) [#4040](https://github.com/IBM/kui/issues/4040)
- add Show Owner Reference button for kube resources ([80ea40f](https://github.com/IBM/kui/commit/80ea40f)), closes [#4106](https://github.com/IBM/kui/issues/4106)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- improve pagination and toolbar UIs of PaginatedTable ([08062e9](https://github.com/IBM/kui/commit/08062e9)), closes [#1456](https://github.com/IBM/kui/issues/1456)
- kubectl tables should show official kind in title ([06eec95](https://github.com/IBM/kui/commit/06eec95)), closes [#4127](https://github.com/IBM/kui/issues/4127)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- render kubectl summary tab using forms ([d88436e](https://github.com/IBM/kui/commit/d88436e)), closes [#4014](https://github.com/IBM/kui/issues/4014)
- resize the popup window ([41bf5cf](https://github.com/IBM/kui/commit/41bf5cf)), closes [#4161](https://github.com/IBM/kui/issues/4161)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- use breadcrumbs for TopNavSidecar naming ([5a4611e](https://github.com/IBM/kui/commit/5a4611e)), closes [#4043](https://github.com/IBM/kui/issues/4043) [#3657](https://github.com/IBM/kui/issues/3657) [#4044](https://github.com/IBM/kui/issues/4044)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

# [8.0.0](https://github.com/IBM/kui/compare/v4.5.0...v8.0.0) (2020-03-20)

### Bug Fixes

- **plugins/plugin-sidecar:** when nameHash is displayed, TopNavSidecar doesn't render the dehashed name ([ef887f4](https://github.com/IBM/kui/commit/ef887f4)), closes [#3969](https://github.com/IBM/kui/issues/3969)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- eliminate use of custom <tab> tag ([00e2728](https://github.com/IBM/kui/commit/00e2728)), closes [#3777](https://github.com/IBM/kui/issues/3777)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- Popup client should place InputStripe inside of StatusStripe ([a09138d](https://github.com/IBM/kui/commit/a09138d)), closes [#3949](https://github.com/IBM/kui/issues/3949)
- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- return an NavResponse without links results in blank page ([e684344](https://github.com/IBM/kui/commit/e684344)), closes [#3927](https://github.com/IBM/kui/issues/3927)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/core:** MMR rendering is glitchy ([5ce89aa](https://github.com/IBM/kui/commit/5ce89aa)), closes [#3589](https://github.com/IBM/kui/issues/3589)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- **plugins/plugin-client-common:** keyboard shortcuts for TopTabStripe aren't working ([24d074f](https://github.com/IBM/kui/commit/24d074f)), closes [#3643](https://github.com/IBM/kui/issues/3643)

### Features

- add history to sidecar views ([b1e5543](https://github.com/IBM/kui/commit/b1e5543)), closes [#3960](https://github.com/IBM/kui/issues/3960)
- carbon tables ([237e9a5](https://github.com/IBM/kui/commit/237e9a5)), closes [#3632](https://github.com/IBM/kui/issues/3632)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)
- left-navigation sidecar ([f88329e](https://github.com/IBM/kui/commit/f88329e)), closes [#3635](https://github.com/IBM/kui/issues/3635)
- new client-alternate for bottom-input mode and custom css ([d25f7a0](https://github.com/IBM/kui/commit/d25f7a0)), closes [#3608](https://github.com/IBM/kui/issues/3608)
- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- refine NavResponse and add NavLinks support in LeftNavSidecar ([f1d8d98](https://github.com/IBM/kui/commit/f1d8d98)), closes [#3902](https://github.com/IBM/kui/issues/3902)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- support ReactElement as MultiModalResponse modes ([a20e289](https://github.com/IBM/kui/commit/a20e289)), closes [#3793](https://github.com/IBM/kui/issues/3793)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)

## [6.0.12](https://github.com/IBM/kui/compare/v6.0.11...v6.0.12) (2020-02-03)

**Note:** Version bump only for package @kui-shell/test

## [6.0.11](https://github.com/IBM/kui/compare/v6.0.10...v6.0.11) (2020-02-03)

### Bug Fixes

- **packages/core:** MMR rendering is glitchy ([d314439](https://github.com/IBM/kui/commit/d314439)), closes [#3589](https://github.com/IBM/kui/issues/3589)

## [6.0.10](https://github.com/IBM/kui/compare/v6.0.9...v6.0.10) (2020-02-01)

**Note:** Version bump only for package @kui-shell/test

## [6.0.9](https://github.com/IBM/kui/compare/v6.0.8...v6.0.9) (2020-01-31)

**Note:** Version bump only for package @kui-shell/test

## [6.0.8](https://github.com/IBM/kui/compare/v4.5.0...v6.0.8) (2020-01-30)

### Bug Fixes

- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)

### Features

- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)

## [6.0.7](https://github.com/IBM/kui/compare/v4.5.0...v6.0.7) (2020-01-30)

### Bug Fixes

- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)

### Features

- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)

## [6.0.6](https://github.com/IBM/kui/compare/v4.5.0...v6.0.6) (2020-01-30)

### Bug Fixes

- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)

### Features

- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)

## [6.0.5](https://github.com/IBM/kui/compare/v4.5.0...v6.0.5) (2020-01-29)

### Bug Fixes

- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)

### Features

- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)

## [6.0.4](https://github.com/IBM/kui/compare/v6.0.3...v6.0.4) (2020-01-28)

**Note:** Version bump only for package @kui-shell/test

## [6.0.3](https://github.com/IBM/kui/compare/v4.5.0...v6.0.3) (2020-01-28)

### Bug Fixes

- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)

### Features

- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)

## [6.0.2](https://github.com/IBM/kui/compare/v4.5.0...v6.0.2) (2020-01-28)

### Bug Fixes

- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)

### Features

- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)

## [6.0.1](https://github.com/IBM/kui/compare/v4.5.0...v6.0.1) (2020-01-28)

### Bug Fixes

- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)

### Features

- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)

# [6.0.0](https://github.com/IBM/kui/compare/v4.5.0...v6.0.0) (2020-01-27)

### Bug Fixes

- reducing flashing effect for PTY command not found errors ([f160337](https://github.com/IBM/kui/commit/f160337)), closes [#3449](https://github.com/IBM/kui/issues/3449)
- **packages/core:** mmr couldn't show up when the sidecar is minimized ([91cd2cc](https://github.com/IBM/kui/commit/91cd2cc)), closes [#3164](https://github.com/IBM/kui/issues/3164)
- **packages/test:** runMochaLayersv2.sh should export WEBPACK_CLIENT_URL ([14fcdc9](https://github.com/IBM/kui/commit/14fcdc9)), closes [#3407](https://github.com/IBM/kui/issues/3407)
- improve windows build support ([cacd68b](https://github.com/IBM/kui/commit/cacd68b)), closes [#3332](https://github.com/IBM/kui/issues/3332)
- **packages/test:** nameHash waitUntil does not use waitTimeout ([5c996f4](https://github.com/IBM/kui/commit/5c996f4)), closes [#3246](https://github.com/IBM/kui/issues/3246)
- another fix for codecov ([0b10599](https://github.com/IBM/kui/commit/0b10599)), closes [#3217](https://github.com/IBM/kui/issues/3217)
- **packages/core:** sidecar basic function should not require plugins ([07aa3e3](https://github.com/IBM/kui/commit/07aa3e3)), closes [#3172](https://github.com/IBM/kui/issues/3172)
- **packages/test:** runMochaLayers versus external clients ([89578dc](https://github.com/IBM/kui/commit/89578dc)), closes [#3106](https://github.com/IBM/kui/issues/3106)

### Features

- pty should allow for streaming consumption of output ([1886e58](https://github.com/IBM/kui/commit/1886e58)), closes [#3451](https://github.com/IBM/kui/issues/3451)
- support generating es6 modules ([c1ed680](https://github.com/IBM/kui/commit/c1ed680)), closes [#2431](https://github.com/IBM/kui/issues/2431)
- **packages/core:** pass a PreloadRegistrar to plugin preloaders ([54d727a](https://github.com/IBM/kui/commit/54d727a)), closes [#3189](https://github.com/IBM/kui/issues/3189)
- **packages/core:** support updating Table from push notifications ([6bfb255](https://github.com/IBM/kui/commit/6bfb255)), closes [#3295](https://github.com/IBM/kui/issues/3295)
- client test ([4c16985](https://github.com/IBM/kui/commit/4c16985)), closes [#3130](https://github.com/IBM/kui/issues/3130)
- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)

# [5.1.0](https://github.com/IBM/kui/compare/v4.5.0...v5.1.0) (2019-10-11)

### Features

- enable plugin-manager for electron clients ([4814cb9](https://github.com/IBM/kui/commit/4814cb9)), closes [#2935](https://github.com/IBM/kui/issues/2935)

# [5.0.0](https://github.com/IBM/kui/compare/v4.5.0...v5.0.0) (2019-10-03)

**Note:** Version bump only for package @kui-shell/test
